L 1 "../Functions.c"
N#define __FUNCTIONS__C
N
N#include <Main.h>
L 1 "E:/TI_workspase/c6701_t/Main.h" 1
N/*
N * main.h
N *
N *  Created on: 6 . 2020 .
N *      Author: Anton
N */
N
N#ifndef MAIN_H_
N#define MAIN_H_
N
N#include <myTypes.h>
L 1 "E:/TI_workspase/c6701_t/myTypes.h" 1
N/*
N * myTypes.h
N */
N
N#ifndef MYTYPES_H_
N#define MYTYPES_H_
N
N/* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
N
Ntypedef unsigned long long	Uint64;
N
N/* Signed integer definitions (32bit, 16bit, 8bit) follow... */
Ntypedef long long			Int64;
N
Ntypedef unsigned long long  uint64;
Ntypedef unsigned int        Uint32;
Ntypedef unsigned int        uint32;
Ntypedef unsigned short      uint16;
Ntypedef unsigned short      Uint16;
Ntypedef unsigned char       uint8;
N
N/* Signed integer definitions (32bit, 16bit, 8bit) follow... */
Ntypedef long long           int64;
Ntypedef int                 int32;
Ntypedef short               int16;
Ntypedef char                int8;
N
N
N
Ntypedef float				Float32;
Ntypedef double				Float64;
N
N/* Constants */
N#ifndef TRUE
N#define TRUE				((Bool) 1)
N#endif
N
N#ifndef FALSE
N#define FALSE				((Bool) 0)
N#endif
N
N#ifndef NULL
N#define NULL    			((void*) 0 )
N#endif
N
N#endif /* MYTYPES_H_ */
L 12 "E:/TI_workspase/c6701_t/Main.h" 2
N#define M_PI 3.14159265358979323846f
N
N#define CHIP_6701 1
N#define flagISRPLIS_mask  0x00000001;
N#define flagTochGot_mask  0x00000002;
N#define flagVPICom_mask  0x00000004;
N
Ntypedef struct //   
N{
N    Uint32 flagISRPLIS : 1; //     
N    Uint32 flagTochGot : 1; //       ()
N    Uint32 flagVPICom : 1;  //       (  )
N    Uint32 ChangePLLflag : 1;  //      ( / )
N    Uint32 ChangeCikl : 1;  //     ( / )
N    Uint32 VPI_Buf_flag : 1;  //    (10  )
N}   TProgram_Flag;
N
Ntypedef struct                       // 
N{
N    Uint32 pll_flags:          4;  // 
N    Uint32 ampl_flag:          4;  //  .
N    Uint32 quadr_flag:         4;  //  
N    Uint32 angl_flag:          4;  //  
N                                    //0  /    
N                                    //1   
N                                    //2    
N                                    //3  
N    Uint32 ampl_stabilised:     1;  //   / 
N    Uint32 big_speed:           1;  //    
N    Uint32 big_angle:           1;  //     
N    Uint32 mode_TVG:            3;  //      腻
N    Uint32 functional_ready:    1;  //  
N    Uint32 accuracy_ready:      1;  //  
N    Uint32 mode_tecnology:      2;  //  - :
N                                    //00  ;
N                                    //01    ;
N                                    //10   ;
N                                    //11   ,  .
N    Uint32 time_out_of_range:   1;  //  
N    Uint32 angle_out_of_range:  1;  //   
N    Uint32 error_out_of_range:  1;  //  
N    Uint32 en_var:              1;  //  
N    Uint32 mode_abonent:        2;  //  :
N                                    //00   ; 01   ; 11   .
N} Tsystem_flags_s;
N
Ntypedef struct //   
N{
N    Uint32 flagVPICom : 1;  //       (  )
N    Uint32 VPI_Buf_flag : 1;  //    (10  )
N    Uint32 ChangeBuf : 1;  //      ( / )
N    Uint32 TempReady : 1;  //    (10  )
N}   TVPI_Flag;
N
Nextern volatile Tsystem_flags_s sysflag;
Nextern volatile TProgram_Flag Program_Flag;
Nextern volatile TVPI_Flag VPI_flag;
N
N
N#endif /* MAIN_H_ */
L 4 "../Functions.c" 2
N#include <RAM.h>
L 1 "E:/TI_workspase/c6701_t/RAM.h" 1
N#ifndef RAM_H_
N#define RAM_H_
N
N#include "myTypes.h"
N
N
N#define wrong		0xFFFF
N#define wronglong	0xFFFFFFFF
N#define LENBUF 1000 
Nenum typereg
N{
N	nothing,
N	rawplis,
N	startmaxtime,
N	stopmaxtime,
N	startevent,
N	stopevent,
N	pending,
N	finish
N};
Nenum typeevent
N{
N	space,
N	onemore,
N	oneless,
N	fourmore,
N	fourless
N};
N
Ntypedef union r_s
N{
N	struct
N	{
N		Uint16  regtype;
N		Uint16  eventtype;
N		float threshold;
N		Uint16 adress[4];
N	}reg;
N	Uint16 arr[8];
N}ssp;
N
Ntypedef struct kolco_s
N{
N    Uint32* p1;
N    Uint32* p2;
N    Uint32* p3;
N    Uint32* p4;
N    int stop;
N    int index;
N    char flag;
N}kolco;
Nvoid initbuf();
Nvoid initssp(Uint16* arr);
Nvoid rawservice();
Nvoid putpoint(Uint32 par1,Uint32 par2,Uint32 par3,Uint32 par4);
Nvoid getpoints();
N
N//   ------
N//Uint16 returnadress(void* val);
N//int WriteRamAnyWords(Uint16 adr, Uint16* buf, Uint16 cnt);
Nint SetBuferAnswer(Uint16 adr, Uint16 c);
N
N#endif /*RAM_H_*/
L 5 "../Functions.c" 2
N#include "myTypes.h"
N#include "Functions.h"
L 1 "..\Functions.h" 1
N#ifndef _FUNCTIONS_H_
N#define _FUNCTIONS_H_
N
N#include "myTypes.h"
N#include "Main.h"
N
N
N#define MaxFreq 0x00001DCD65000000 // = 32768000000000 = 62,5e6 * 2^32 / 8192 = 7629,39453125  * 2^32
N#define c2v31  0x0000000080000000
N#define c2v31_1  0x000000007FFFFFFF
N#define c2v32  0x0000000100000000
N#define c2v62  0x4000000000000000
N#define c2v63_1  0x7FFFFFFFFFFFFFFF
N#define int_pi  0x03243F6A
N#define int_2pi  0x06487ED5
N#define int_pi2  0x01921FB5
N#define int_pi4  0x00C90FDA
N#define int_sqrt2_2  0x5A827999
N#define int_sqrt2  0x00000000B504F333
N
N
N
Ntypedef struct //  
N{
N    int64 sum;
N    int64 last_out;
N    int32 last_a;
N} InFLTR_s;
N
Ntypedef struct //  
N{
N    int64 Angl_sp_out;  //     (    f/MaxFreq - 2^31 = 1 rad/sec)
N    int32 Z1;   //  (1 )
N    int32 Z2;   //  (1 )
N    int32 Angl_filt; //  (2 )
N    int32 Last_Z2; //   (2 )
N    int32 Angl_fut; //   ( )
N    int32 Angl_K0; // . 1 
N    int32 Angl_K1; // . 2 
N    int64 ASpeed_K1; // .    
N    int32 ASpeed_K2; // .  1      Angl_fut
N    int32 last_cikl; //  
N    int32 P;  // Wcp / F0 -   
N    int32 PdivQ;  // P / q -   ,   
N    int32 Msht;  //  
N} AnglFltr_s;
N
Nint32 Spec_mult (int32 sma, int32 kff);
Nvoid int_long_mult (int64 , int32 );
Nint32 int_sqrt1 (int64 );
Nint32 int_sin (int32 );
Nint32 int_cos (int32 );
Nint32 int_arcsin (int32, int32 );
Nvoid korr_fltr (InFLTR_s *filtr, int32 a);
Nint32 int_filter1 (int32 x, InFLTR_s *filtr);
Nvoid korr_angl_filter (int32 cycle);
Nvoid init_angl_filter (void);
Nvoid Reset_angl_filter (void);
Nvoid angl_filter (int32);
Nint32 Spec_int64_div (int64, int64);
Nint32 Spec_int_div (int32, int32);
Nvoid InFiltrInit (void);
Nint32 CalcFullAngle (int32 sinx, int32 cosx);
Nvoid Set_koef_angl_filter (int32 cycle);
Nextern AnglFltr_s SAngl;
Nextern int32 int_Angle_set;
Nextern int64 rez_mult;
N#endif /* _FUNCTIONS_H_ */
L 7 "../Functions.c" 2
N#include <System_unit.h>
L 1 "E:/TI_workspase/c6701_t/System_unit.h" 1
N#ifndef _SYSTEM_UNIT_H_
N#define _SYSTEM_UNIT_H_
N
N#include <Main.h>
N#include <RAM.h>
N#include "myTypes.h"
N#include "TVG.h"
L 1 "E:\TI_workspase\c6701_t\TVG.h" 1
N#ifndef TVG_H_
N#define TVG_H_
N
N#include "myTypes.h"
N#include "System_unit.h"
L 1 "E:\TI_workspase\c6701_t\System_unit.h" 1
N#ifndef _SYSTEM_UNIT_H_
S#define _SYSTEM_UNIT_H_
S
S#include <Main.h>
S#include <RAM.h>
S#include "myTypes.h"
S#include "TVG.h"
S#include "Functions.h"
S
S#define Per_To_Freq 119837257 //    .   
S#define int_kpwm 0x00000000A2F9836E // 41721,513402 * 65536
S#define Koef_popr 0x000186A0 // = 100000  .   
S#define MinPeriodTvg 1174405 // = 8192*35*256/62,5     ()
S#define MaxPeriodTvg 1503238 // = (2^32)*8192*35**256/62,5*(0xc800 0000)     ()
S#define AnglMsht 197745696 //      0,00025"
S//3355443200 =0xC800 0000
Stypedef struct //  
S{
S    Uint16 flags;
S    // 0  - /  
S    // 1  -   
S    // 2  -    
S    // 3  -  
S    Uint16 LastFlags;
S    int32 Kc; // K1,  
S    int32 Kf; // K2, 
S    int32 Lim;
S    int32 Ready_Lim; // 
S    int32 Ready_LimiL;
S    int32 Ready_LimiH;
S    int32 Rdy;
S    int64 acc;//
S    Uint32 accL;//
S    int32 out;
S    Uint32 PpcL;//
S    int32 PpcH;
S    InFLTR_s RdyFlt;
S} Kontur_s;
S
Stypedef struct//  
S{
S    int32 Kcg; // Ki,  
S    int32 Kfg; // K2,  
S    int32 Kct; // Ki,  
S    int32 Kft; // K2,  
S    int32 dPLLi; //  
S    int32 out;//   
S    uint32 LastFlags;
S}   PLL_s;
S
Stypedef struct//  
S{
S    int32 Lim_R[3]; // = {Level_Wave * 0.99, Level_Wave * 0.2, Level_Wave * 0.06};   
S    int32 Lim_R_gis; // = Level_Wave * 0.02 -    
S    int32 Level_Wave; // = 1600000000;
S    int32 dNRi; //  
S    int32 out;//   
S    int32 Real_out;//   
S}   Amp_s;
S
Stypedef struct//  
S{
S    int32 dNpi; //  
S    int32 out;//   
S    int32 Real_out;//   
S}   Quadr_s;
S
Stypedef struct angl//  
S{
S    int32 dNai; //  
S    int32 out; //   
S    int32 Real_out;//   
S}   Angl_s;
S
Stypedef struct//  
S{
S    int16 Nx, Ny;
S    int32 Nxacc, Nyacc;
S    int32 sumXY;
S    int32 RazXY;
S}   PWMOut_s;
S
Stypedef struct//  
S{
S//   
S    int32 lastsmp[4];
S    InFLTR_s FFX[4];
S    int32 FXs;
S    int32 FXc;
S    int32 FYs;
S    int32 FYc;
S    int32 XY1;
S    int32 XY2;
S    int32 XY3;
S    int32 XY4;
S    int32 K5K;
S    int32 K6K;
S    int32 R;
S    int32 p;
S    int32 Rp;
S    int32 SApFi;
S    int32 CApFi;
S    int32 SAmFi;
S    int32 CAmFi;
S    int32 ApFi;
S    int32 AmFi;
S    int32 Angletmp;
S    int32 Fitemp;
S    int32 OutR;
S    int32 OutP;
S    int32 Speed_outP;
S    int32 Last_PLL;
S    int32 F_outP;
S    int16 Last_cycle;
S    int16 cycle;
S    int32 Last_Na;
S    int32 Na;
S    int32 Last_AnglFlag;
S    int32 AnglFlag;
S    int32 Nax;
S    int32 Nay;
S    int32 Ksn;
S    int32 Kcs;
S    int32 SetKsn;
S    int32 SetKcs;
S   int16 Last_Ny;
S    int16 Ny;
S} Func_s;
S
Svoid PreCalcFunction (void);
Svoid SecondCalcFunction (void);
Svoid SetOutBuf (int32 csovm);
S
Sint32 PWMOutProc(int32 Nx, PWMOut_s *sysp, int32 ang_raz);
Svoid OutInfoInit(void);
Svoid SetOutBuf (int32 csovm);
Sint32 Calc_CDUS (int32 NA1);
Svoid Calc_Cfee (void);
S
Svoid PLL_Init (void);
Svoid PLL_Reset (void);
Svoid PLL_Process (void);
S
Svoid Ampl_Init (void);
Svoid Ampl_Reset (void);
Svoid Ampl_Process (void);
S
Svoid Quadr_Init (void);
Svoid Quadr_Reset (void);
Svoid Quadr_Process (void);
S
Svoid Angl_Init (void);
Svoid Angl_Reset (void);
Svoid Angl_Process (void);
S
Sextern int32 Rdy_gisterezis; //0.1 * 2^31;    
Sextern int32 ReadyKoef; // Aready = 0,00554 (1 )
Sextern int32 OutLim; // 23160 * 65536     
Sextern int32 PWMLim; // 32704     PWM (max 1022)
S
Sextern int32 Glob_Lim_R[6];
Sextern int32 Temp_koef_0;
Sextern int32 Temp_koef_0_board;
Sextern int32 Korrect_0;
Sextern int32 Temp_koef_masshtab;
Sextern int32 Temp_koef_masshtab_board;
Sextern int32 Korrect_masshtab;
S
Sextern int32 delta_Temp, delta_F;
S
Sextern Func_s Func;
S
S//  
Sextern PLL_s PLL;
Sextern Kontur_s PLL_KK;
S
S//  
Sextern Amp_s Amp;
Sextern Kontur_s Amp_KK;
Sextern PWMOut_s Amp_PWM;
S
S//  
Sextern Quadr_s Quadr;
Sextern Kontur_s Quadr_KK;
Sextern PWMOut_s Quadr_PWM;
S
S//   
Sextern Angl_s AnglS;
Sextern Kontur_s AnglS_KK;
Sextern PWMOut_s AnglS_PWM;
S
S
N#endif /* SOURCE_SYSTEM_UNIT_H_ */
L 6 "E:\TI_workspase\c6701_t\TVG.h" 2
N#include <System_output_information.h>
L 1 "E:/TI_workspase/c6701_t/System_output_information.h" 1
N/*
N * System_output_information.h
N */
N
N#ifndef HEADER_SYSTEM_OUTPUT_INFORMATION_H_
N#define HEADER_SYSTEM_OUTPUT_INFORMATION_H_
N#include <Functions.h>
Ntypedef struct//  
N{
N    int32 ampl;
N    int32 angl;
N    int32 cfree; //    (1 /, ) (161)
N    int32 cdus; //   (1 /, ) (160)
N    int32 csovm; //     () (162)
N    int32 acsel; //   () (163)
N    InFLTR_s FiltrOut; //   
N    InFLTR_s FiltrR; //   
N    InFLTR_s FiltrQ; //   
N    uint8 VarAdr[16];
N    uint8 VarTipe[16];
N    int32 OutFiltrKoef; //    
N    int32 RQFiltrKoef; //     
N    int32 SumAngl;
N    uint32 SumTim;
N    uint64 SumTimLong;
N    uint32 deltaTim;
N    int32 deltaAngl;
N    int32 RegAns[3];
N}   OutInfo_s;
N
Ntypedef struct//  
N{
N    Uint32 outflag;// -   sysflag   system_flags_s
N    int32 outsumangl;// ,    (0,00025 .)
N    int32 outspeed;//  (Na    , 0,001./)
N    Uint32 outtime;//   () ( )
N    Uint32 outdeltatime;//    (    ( )
N    int32 outampl;// ,   R0
N    int32 outquad;// 
N    int32 outangl;//   (  * 2:24 )
N    Uint32 outfreq;// , 
N    Uint32 variables[16];// 
N}   OutInfoVPI_s;
N
N
N
N
N#endif /* HEADER_SYSTEM_OUTPUT_INFORMATION_H_ */
L 7 "E:\TI_workspase\c6701_t\TVG.h" 2
N#include "Functions.h"
N
N
N#define TVG_IN_FIR_TAP		4// 4..64
N#define TVG_PLL_FIR_TAP		3
N#define TVG_NR_FIR_TAP		3
N#define TVG_Np_FIR_TAP		3
N#define TVG_Na_FIR_TAP		3 
N
N#define TVG_IN_FIR_TAP_VES		1//4// 4..64
N#define TVG_PLL_FIR_TAP_VES		1//8
N#define TVG_NR_FIR_TAP_VES		1//8
N#define TVG_Np_FIR_TAP_VES		1//8
N#define TVG_Na_FIR_TAP_VES		1 
N//   R1:
N
N#define TVG_BUF_LEN     100//16
N#define TVG_TABLE_LEN       16
N#define TVG_OZU_LEN     260
N
N#define TVG_TABLE_LEN       16
N
N#define TVG_TEMP_TABLE_DEF  \
N     -52.00,  -40.00,  -28.00,  -16.00,   -4.00,    8.00,   20.00,   32.00, \
N      44.00,   56.00,   68.00,   80.00,   92.00,  104.00,  116.00,  228.00
X#define TVG_TEMP_TABLE_DEF       -52.00,  -40.00,  -28.00,  -16.00,   -4.00,    8.00,   20.00,   32.00,       44.00,   56.00,   68.00,   80.00,   92.00,  104.00,  116.00,  228.00
N
N#define TVG_FREQ_TABLE_DEF  \
N    7257.39, 7264.82, 7272.26, 7279.69, 7287.13, 7294.56, 7302.00, 7309.44, \
N    7316.87, 7324.31, 7331.74, 7339.18, 7346.61, 7354.05, 7361.48, 7368.92
X#define TVG_FREQ_TABLE_DEF      7257.39, 7264.82, 7272.26, 7279.69, 7287.13, 7294.56, 7302.00, 7309.44,     7316.87, 7324.31, 7331.74, 7339.18, 7346.61, 7354.05, 7361.48, 7368.92
N
N
N//   :
Ntypedef enum
N{
N    cntrWork = 0,      // 
N    cntrTechnology,    // 
N    cntrReprogram     // 
N }
NTTVGControlMode;
N
N//   :
Ntypedef enum
N{
N	twsStop = 0,		// 
N	twsGetFreq,			//    5%
N	twsStarting,		//   20%
N	twsRazgon,			//   80%
N	twsStabilization,	//  
N	twsFreeWave,		// 
N	twsAngleReturn,		//  
N	twsBreaking		// 
N//	twsUint16 = 0x7FFF
N}   TTVGWorkState;
N
Ntypedef struct
N{
W "E:\TI_workspase\c6701_t\TVG.h" 63 5 nonstandard type for a bit field
N    unsigned short Nx : 3;//   X
W "E:\TI_workspase\c6701_t\TVG.h" 64 5 nonstandard type for a bit field
N    unsigned short Ny : 3;//   Y
W "E:\TI_workspase\c6701_t\TVG.h" 65 5 nonstandard type for a bit field
N    unsigned short Off : 1;//NRx =max,NRy = 0   ,  1
W "E:\TI_workspase\c6701_t\TVG.h" 66 5 nonstandard type for a bit field
N    unsigned short Off_kvadr_PWM : 1;//    , 1  - ;
W "E:\TI_workspase\c6701_t\TVG.h" 67 5 nonstandard type for a bit field
N    unsigned short Off_angle_PWM : 1;//     , 1  - 
W "E:\TI_workspase\c6701_t\TVG.h" 68 5 nonstandard type for a bit field
N    unsigned short Off_korrect_PWM : 1;//    , 1 - 
W "E:\TI_workspase\c6701_t\TVG.h" 69 5 nonstandard type for a bit field
N    unsigned short simul_DATA : 1;// X_C, X_S,Y_S, Y_C,  1  
W "E:\TI_workspase\c6701_t\TVG.h" 70 5 nonstandard type for a bit field
N    unsigned short none1 : 2;
W "E:\TI_workspase\c6701_t\TVG.h" 71 5 nonstandard type for a bit field
N    unsigned short test_razgona : 1;//      
W "E:\TI_workspase\c6701_t\TVG.h" 72 5 nonstandard type for a bit field
N    unsigned short short_FD : 1;///  , 1  
W "E:\TI_workspase\c6701_t\TVG.h" 73 5 nonstandard type for a bit field
N    unsigned short inc_PLL : 1;//  , 0   
N}   TTVGR1;
N
Ntypedef struct
N{
N	Uint32 StopCnt; //    
N	TTVGWorkState WorkState;
N	TTVGControlMode ControlMode;
N	Uint32 directPWM;
N    int32 InFtrKoefGr;
N    int32 InFtrKoefTch;
N    int32 Ttvg;		//  , C * 100 (+2000 = 20C)
N    int32 Tpl;      //  , C * 100 (+2000 = 20C)
N    int32 T0;      //  , C * 100 (+2000 = 20C)
N	Uint32 f0;	//     ,    (,   0xc800 0000)
N    int32 Kf0;  //       ,     0,01C
N    Uint32 f00;  //     ,    (,   0xc800 0000)
N	TTVGR1 R1;	//   R1
N	int32 DeltaMshT; //   1   
N	int32 TimFiltrKoef; //     
N    int32 BruinKoef; //   (       )
N    int32 SetAngl; //  
N    int32 SetAngl_temp; //    
N    int32 Tkoef_SetAngl; //  ( )    (.100000)
N    int32 Speed_Korrekt; //        
N    int32 Angl_gr;      //      /  
N    int32 W_gr;         //       / 
N    int32 Angl_gis;    //   /    
N    int32 W_gis;       //   /     
N    int32 PWM_korr; //   
N}   tvg_s;
N
Ntypedef struct//   
N{ 
N	int32 Xs; 
N	int32 Xc; 
N	int32 Ys; 
N	int32 Yc; 
N	int32 S; 
N	int16 regINVERS;
N}	tvgIn_s;
N
Ntypedef struct//   
N{
N	Uint32 PLL;
N	Uint32 F0;
N	int16 Nrx;
N	int16 Nry;
N	int16 Npx;
N	int16 Npy;
N	int16 Nax;
N	int16 Nay;
N	TTVGR1 R1;
N	Uint16 R2; 
N	int16 NrPWM;
N	int16 NpPWM;
N	int16 NaPWM;
N}   tvgOut_s;
N
N
N
Nvoid InitAdres(void);
Nvoid tvgInit ( void );
NUint32 tvgGetF0 (void);
Nvoid tvgStopInit (void);
N
Nvoid tvgSetState();
Nvoid tvgStopProcess (void);
Nvoid tvgGetFreqProcess (void);
Nvoid tvgStartingProcess (void);
Nvoid tvgRazgonProcess (void);
Nvoid tvgStabilizationProcess (void);
Nvoid tvgFreeWaveProcess (void);
Nvoid tvgAngleReturnProcess (void);
Nvoid tvgBreakingProcess (void);
Nvoid tvgOutInfoProcess(void);
N
Nextern OutInfo_s OutInfo;
Nextern OutInfoVPI_s Buf0, Buf1;//
Nextern tvg_s tvg;
N//   
Nextern volatile tvgIn_s	tvgIn;
N//   
Nextern volatile tvgOut_s tvgOut;
N//  
Nextern OutInfo_s OutInfo;
Nextern uint32 SearchDeltaF;
N
N
N#endif /*TVG_H_*/
L 8 "E:/TI_workspase/c6701_t/System_unit.h" 2
N#include "Functions.h"
N
N#define Per_To_Freq 119837257 //    .   
N#define int_kpwm 0x00000000A2F9836E // 41721,513402 * 65536
N#define Koef_popr 0x000186A0 // = 100000  .   
N#define MinPeriodTvg 1174405 // = 8192*35*256/62,5     ()
N#define MaxPeriodTvg 1503238 // = (2^32)*8192*35**256/62,5*(0xc800 0000)     ()
N#define AnglMsht 197745696 //      0,00025"
N//3355443200 =0xC800 0000
Ntypedef struct //  
N{
N    Uint16 flags;
N    // 0  - /  
N    // 1  -   
N    // 2  -    
N    // 3  -  
N    Uint16 LastFlags;
N    int32 Kc; // K1,  
N    int32 Kf; // K2, 
N    int32 Lim;
N    int32 Ready_Lim; // 
N    int32 Ready_LimiL;
N    int32 Ready_LimiH;
N    int32 Rdy;
N    int64 acc;//
N    Uint32 accL;//
N    int32 out;
N    Uint32 PpcL;//
N    int32 PpcH;
N    InFLTR_s RdyFlt;
N} Kontur_s;
N
Ntypedef struct//  
N{
N    int32 Kcg; // Ki,  
N    int32 Kfg; // K2,  
N    int32 Kct; // Ki,  
N    int32 Kft; // K2,  
N    int32 dPLLi; //  
N    int32 out;//   
N    uint32 LastFlags;
N}   PLL_s;
N
Ntypedef struct//  
N{
N    int32 Lim_R[3]; // = {Level_Wave * 0.99, Level_Wave * 0.2, Level_Wave * 0.06};   
N    int32 Lim_R_gis; // = Level_Wave * 0.02 -    
N    int32 Level_Wave; // = 1600000000;
N    int32 dNRi; //  
N    int32 out;//   
N    int32 Real_out;//   
N}   Amp_s;
N
Ntypedef struct//  
N{
N    int32 dNpi; //  
N    int32 out;//   
N    int32 Real_out;//   
N}   Quadr_s;
N
Ntypedef struct angl//  
N{
N    int32 dNai; //  
N    int32 out; //   
N    int32 Real_out;//   
N}   Angl_s;
N
Ntypedef struct//  
N{
N    int16 Nx, Ny;
N    int32 Nxacc, Nyacc;
N    int32 sumXY;
N    int32 RazXY;
N}   PWMOut_s;
N
Ntypedef struct//  
N{
N//   
N    int32 lastsmp[4];
N    InFLTR_s FFX[4];
N    int32 FXs;
N    int32 FXc;
N    int32 FYs;
N    int32 FYc;
N    int32 XY1;
N    int32 XY2;
N    int32 XY3;
N    int32 XY4;
N    int32 K5K;
N    int32 K6K;
N    int32 R;
N    int32 p;
N    int32 Rp;
N    int32 SApFi;
N    int32 CApFi;
N    int32 SAmFi;
N    int32 CAmFi;
N    int32 ApFi;
N    int32 AmFi;
N    int32 Angletmp;
N    int32 Fitemp;
N    int32 OutR;
N    int32 OutP;
N    int32 Speed_outP;
N    int32 Last_PLL;
N    int32 F_outP;
N    int16 Last_cycle;
N    int16 cycle;
N    int32 Last_Na;
N    int32 Na;
N    int32 Last_AnglFlag;
N    int32 AnglFlag;
N    int32 Nax;
N    int32 Nay;
N    int32 Ksn;
N    int32 Kcs;
N    int32 SetKsn;
N    int32 SetKcs;
N   int16 Last_Ny;
N    int16 Ny;
N} Func_s;
N
Nvoid PreCalcFunction (void);
Nvoid SecondCalcFunction (void);
Nvoid SetOutBuf (int32 csovm);
N
Nint32 PWMOutProc(int32 Nx, PWMOut_s *sysp, int32 ang_raz);
Nvoid OutInfoInit(void);
Nvoid SetOutBuf (int32 csovm);
Nint32 Calc_CDUS (int32 NA1);
Nvoid Calc_Cfee (void);
N
Nvoid PLL_Init (void);
Nvoid PLL_Reset (void);
Nvoid PLL_Process (void);
N
Nvoid Ampl_Init (void);
Nvoid Ampl_Reset (void);
Nvoid Ampl_Process (void);
N
Nvoid Quadr_Init (void);
Nvoid Quadr_Reset (void);
Nvoid Quadr_Process (void);
N
Nvoid Angl_Init (void);
Nvoid Angl_Reset (void);
Nvoid Angl_Process (void);
N
Nextern int32 Rdy_gisterezis; //0.1 * 2^31;    
Nextern int32 ReadyKoef; // Aready = 0,00554 (1 )
Nextern int32 OutLim; // 23160 * 65536     
Nextern int32 PWMLim; // 32704     PWM (max 1022)
N
Nextern int32 Glob_Lim_R[6];
Nextern int32 Temp_koef_0;
Nextern int32 Temp_koef_0_board;
Nextern int32 Korrect_0;
Nextern int32 Temp_koef_masshtab;
Nextern int32 Temp_koef_masshtab_board;
Nextern int32 Korrect_masshtab;
N
Nextern int32 delta_Temp, delta_F;
N
Nextern Func_s Func;
N
N//  
Nextern PLL_s PLL;
Nextern Kontur_s PLL_KK;
N
N//  
Nextern Amp_s Amp;
Nextern Kontur_s Amp_KK;
Nextern PWMOut_s Amp_PWM;
N
N//  
Nextern Quadr_s Quadr;
Nextern Kontur_s Quadr_KK;
Nextern PWMOut_s Quadr_PWM;
N
N//   
Nextern Angl_s AnglS;
Nextern Kontur_s AnglS_KK;
Nextern PWMOut_s AnglS_PWM;
N
N
N#endif /* SOURCE_SYSTEM_UNIT_H_ */
L 8 "../Functions.c" 2
N#include "Main.h"
N
N
Nint64 num;
Nint64 ost;
Nint64 tsm;
Nint64 rez_mult;
Nint64 rez;
Nint64 V;
Nint32 n;
Nint64 sum;
Nint64 ff;
Nint32 r;
Nint32 delta;
Nint64 tmps, tmps1;
Nint32 flg;
NAnglFltr_s SAngl;
N
Nint32 int_Angle_set;
N////////////////////////////////////////////////////////////////////////////////
N//   32-   . < 1
N// : int32 sma -   ( ),
N//     int32 kff - , +-2^31  ,    ,  .
N// : int32   sma  kff
N////////////////////////////////////////////////////////////////////////////////
Nint32 Spec_mult (int32 sma, int32 kff)
N{
N
N    num = (int64)sma; ost = (int64)kff;
N    tsm = num * ost;
N    tsm = tsm >> 31;
N    return (int32)tsm; // return (int32)( ( (int64)sma * (int64)kff ) >> 31) ;
N}
N////////////////////////////////////////////////////////////////////////////////
N//   64-   . < 1
N// : int64 sma -   ( ),
N//     int32 kff - , +-2^31  ,    ,  .
N// : int64  rez_mult   sma
N////////////////////////////////////////////////////////////////////////////////
Nvoid int_long_mult (int64 sma, int32 kff)
N{
N
N    num = sma;
N    if (sma < 0)
N        num = -num;
N    tsm = (int64) kff;
N    if (kff < 0)
N        tsm = -tsm;
N//	tsm = tsm & c2v31_1;
N    ost = num >> 32;
N    num &= 0x00000000FFFFFFFF;
N    num = (num * tsm) >> 31;
N    ost = ((ost * tsm) << 1) + num;
N    if ((sma < 0) && (kff > 0) || (sma > 0) && (kff < 0))
N        rez_mult = -ost;
N    else
N        rez_mult = ost;
N    return;
N}
N////////////////////////////////////////////////////////////////////////////////
N//   
N////////////////////////////////////////////////////////////////////////////////
Nint32 int_sqrt1 (int64 x)
N{
N
N	ost = x;
N	if (ost < 0) return -1;
N	ff = c2v62 >> 2;
X	ff = 0x4000000000000000 >> 2;
N	rez = 0;
N	while (ff > 0)
N	{
N		tsm = rez + ff;
N		rez = rez >> 1;
N		if ( tsm < ost)
N		{
N			ost -= tsm; 
N			rez += ff;
N		};
N		ff = ff >> 2;
N	};
N	r = (int32) rez;
N	return r;
N}
N
N
N////////////////////////////////////////////////////////////////////////////////
N// 
N// : int32 ugol (2^24 = 1 )  |ugol|< 2^31 (   +-pi/2)
N// : int32 (.. 2^31 = 1,  +-2^31  ,    
N////////////////////////////////////////////////////////////////////////////////
Nint32 int_sin (int32 ugol)
N{
Nstatic const int32 tabl_sin[8] = {	0x15555555,
N								0x06666666,
N								0x030C30C3,
N								0x01C71C72,
N								0x0129E413,
N								0x00D20D21,
N								0x009C09C1,
N								0x00787878 };
N
N	n=0;
N	// 
N	delta = ugol;
N	if (delta < 0) delta = -delta;
N	if (delta >= int_2pi) delta = delta % int_2pi;
X	if (delta >= 0x06487ED5) delta = delta % 0x06487ED5;
N	if (delta >= int_pi + int_pi2) delta = delta - int_2pi;
X	if (delta >= 0x03243F6A + 0x01921FB5) delta = delta - 0x06487ED5;
N	if (delta > int_pi2) delta = int_pi - delta;
X	if (delta > 0x01921FB5) delta = 0x03243F6A - delta;
N	if (ugol < 0) delta = - delta;
N	//  
N	sum = ((int64) delta) << 7;
N	tmps = sum;
N	tmps = (tmps * sum) >> 31;
N	V = sum;
N	//  
N	do
N	{
N		tmps1 = (tmps * tabl_sin[n]) >> 31;
N		tmps1 = tmps1 * (-V);
N		V = tmps1 >> 31;
N		sum += V;
N		n++;
N		if (( V > c2v31_1) ||  ( V < -c2v31_1)) { delta = c2v31_1; }
X		if (( V > 0x000000007FFFFFFF) ||  ( V < -0x000000007FFFFFFF)) { delta = 0x000000007FFFFFFF; }
N		else  { if ( V < 0) { delta = -V;} else { delta = V;}; };
N	} while ((n < 8) && (delta > 0x00000003));
N	//  
N	if ( sum > c2v31_1)  sum = c2v31_1;
X	if ( sum > 0x000000007FFFFFFF)  sum = 0x000000007FFFFFFF;
N	if ( sum < -c2v31_1)  sum = -c2v31_1;
X	if ( sum < -0x000000007FFFFFFF)  sum = -0x000000007FFFFFFF;
N	// 
N	return (int32) sum;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N// 
N// : int32 ugol (2^24 = 1 )  |ugol|< 2^31 (   +-pi/2)
N// : int32 (.. 2^31 = 1,  +-2^31  ,    
N////////////////////////////////////////////////////////////////////////////////
Nint32 int_cos (int32 ugol)
N{
Nstatic	const int32 tabl_cos[9] = { 0x40000000,
N								0x0AAAAAAB,
N								0x04444444,
N								0x02492492,
N								0x016C16C1,
N								0x00F83E10,
N								0x00B40B41,
N								0x00888889,
N								0x006B15C0 };
N
N	n=0;
N	// 
N	delta = ugol;
N	if (delta < 0) delta = -delta;
N	if (delta >= int_2pi) delta = delta % int_2pi;
X	if (delta >= 0x06487ED5) delta = delta % 0x06487ED5;
N	if (delta > int_pi) delta = int_2pi - delta;
X	if (delta > 0x03243F6A) delta = 0x06487ED5 - delta;
N	//  
N	tmps = ((int64) delta) << 7;
N	tmps = (tmps * tmps) >> 31;
N	V = c2v31;
X	V = 0x0000000080000000;
N	sum = c2v31;
X	sum = 0x0000000080000000;
N	//  
N	do
N	{
N		tmps1 = (tmps * tabl_cos[n]) >> 31;
N		tmps1 = tmps1 * (-V);
N		V = tmps1 >> 31;
N		sum += V;
N		n++;
N		if (( V > c2v31_1) ||  ( V < -c2v31_1)) { delta = c2v31_1; }
X		if (( V > 0x000000007FFFFFFF) ||  ( V < -0x000000007FFFFFFF)) { delta = 0x000000007FFFFFFF; }
N		else  { if ( V < 0) { delta = -V;} else { delta = V;}; };
N	} while ((n < 9) && (delta > 0x00000003));
N	//  
N	if ( sum > c2v31_1)  sum = c2v31_1;
X	if ( sum > 0x000000007FFFFFFF)  sum = 0x000000007FFFFFFF;
N	if ( sum < -c2v31_1)  sum = -c2v31_1;
X	if ( sum < -0x000000007FFFFFFF)  sum = -0x000000007FFFFFFF;
N	// 
N	return (int32) sum;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N// 
N// : int32 (.. 2^31 = 1,  +-2^31  ,    , 1   
N// prec int32 - ,  "+",  1 ( ),  1024
N// :  int32 ugol (2^24 = 1 )  +-pi/2
N////////////////////////////////////////////////////////////////////////////////
N
Nint32 int_arcsin (int32 x, int32 prec)
N{
Nstatic const int32 tabl_asin[23] = {0x15555555,    0x3999999A,     0x4C30C30C,     0x571C71C7,
N	                             0x5E4129E4,    0x63483483,     0x67027027,     0x69E1E1E2,
N	                             0x6C29EB0A,    0x6E04E04E,     0x6F8EAC04,     0x70DA740E,
N	                             0x71F5CA07,    0x72EA8FC3,     0x73C0233C,     0x747C1F08,
N	                             0x7522D9B5,    0x75B7BC59,     0x763D7ECA,     0x76B6526B,
N	                             0x77240122,    0x77880423,     0x77E394F5	};
N	
N
N	n=0; flg = 0;
N	//   sqrt(2)/2
N	delta = x;
N	if (x < 0) delta = -delta;
N	if (delta >= int_sqrt2_2)
X	if (delta >= 0x5A827999)
N	{
N		tmps1 = ((int64) delta);
N		tmps = c2v62 - (tmps1 * tmps1);
X		tmps = 0x4000000000000000 - (tmps1 * tmps1);
N		delta = int_sqrt1 (tmps);
N		flg = 1;
N		tmps = tmps >> 31;
N	}
N	else
N	{
N		tmps = ((int64) delta);
N		tmps = (tmps * tmps) >> 31;
N	};
N	//  
N	V = (int64)delta;
N	sum = (int64)delta;
N	//  
N	do
N	{
N		tmps1 = (tmps * tabl_asin[n]) >> 31;
N		tmps1 = tmps1 * V;
N		V = tmps1 >> 31;
N		sum += V;
N		n++;
N		if ( V > c2v31_1) { delta = c2v31_1; }
X		if ( V > 0x000000007FFFFFFF) { delta = 0x000000007FFFFFFF; }
N		else  { delta = V;};
N	} while ((n < 23) && (delta > (prec << 6)));
N	//  
N	tmps = ((int64) int_pi4) << 7;
X	tmps = ((int64) 0x00C90FDA) << 7;
N	if ( sum > tmps)  { delta = int_pi4; }
X	if ( sum > tmps)  { delta = 0x00C90FDA; }
N	else { delta = (int32)(sum >> 7); };
N	if (flg) delta = int_pi2 - delta;
X	if (flg) delta = 0x01921FB5 - delta;
N	if (x < 0) delta = -delta;
N	// 
N	return delta;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N//       
N//  *filtr -     
N//  -    ()
N////////////////////////////////////////////////////////////////////////////////
Nvoid korr_fltr (InFLTR_s *filtr, int32 a)
N{
N    filtr->sum =  ( filtr->last_out << 31 ) / a;
N    filtr->last_a = a;
N    return;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N//    
N////////////////////////////////////////////////////////////////////////////////
Nvoid InFiltrInit (void)
N{
N    Uint16 i;
N    for (i = 0; i < 4; i++)
N    {
N        Func.FFX[i].last_out = 0; //  
N        korr_fltr (&Func.FFX[i], tvg.InFtrKoefGr); //   
N        Func.lastsmp[i] = 0; //  
N    };
N    return;
N}
N////////////////////////////////////////////////////////////////////////////////
N//   1 
N//  -   ,
N//  *filtr -    
N//  -  
N//    
N//      ( )
N////////////////////////////////////////////////////////////////////////////////
Nint32 int_filter1 (int32 x, InFLTR_s *filtr)
N{
N	filtr->sum += ((int64)x - filtr->last_out);
N	int_long_mult (filtr->sum, filtr->last_a);
N	filtr->last_out = rez_mult;
N	if (rez_mult > c2v31_1) rez_mult = c2v31_1;
X	if (rez_mult > 0x000000007FFFFFFF) rez_mult = 0x000000007FFFFFFF;
N	if (rez_mult < -c2v31_1) rez_mult = -c2v31_1;
X	if (rez_mult < -0x000000007FFFFFFF) rez_mult = -0x000000007FFFFFFF;
N	return (int32)rez_mult;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N//         
N////////////////////////////////////////////////////////////////////////////////
N
Nvoid korr_angl_filter (int32 deltaASpeed)
N{
N    int64 tmps;
N    OutInfo.cfree = OutInfo.cfree + deltaASpeed;
N    tmps = ((int64)OutInfo.cfree * (int64)tvg.BruinKoef);
N    tmps = tmps / (int64)Func.F_outP;
N    if (tmps > c2v31_1)
X    if (tmps > 0x000000007FFFFFFF)
N        tmps = c2v31_1;
X        tmps = 0x000000007FFFFFFF;
N    if (tmps < -c2v31_1)
X    if (tmps < -0x000000007FFFFFFF)
N        tmps = -c2v31_1;
X        tmps = -0x000000007FFFFFFF;
N    SAngl.Angl_sp_out = tmps;
N    tmps = (tmps << 31) / SAngl.ASpeed_K1;
N    if (tmps > c2v31_1)
X    if (tmps > 0x000000007FFFFFFF)
N        tmps = c2v31_1;
X        tmps = 0x000000007FFFFFFF;
N    if (tmps < -c2v31_1)
X    if (tmps < -0x000000007FFFFFFF)
N        tmps = -c2v31_1;
X        tmps = -0x000000007FFFFFFF;
N    SAngl.Z1 = (int32)tmps;
N    return;
N}
N////////////////////////////////////////////////////////////////////////////////
N//      
N////////////////////////////////////////////////////////////////////////////////
N
Nvoid Set_koef_angl_filter (int32 cycle)
N{
N    SAngl.ASpeed_K2 = SAngl.PdivQ * cycle;
N    SAngl.Angl_K0 = (int32)c2v31_1 - SAngl.ASpeed_K2 + 1;
X    SAngl.Angl_K0 = (int32)0x000000007FFFFFFF - SAngl.ASpeed_K2 + 1;
N    SAngl.Angl_K1 = SAngl.P * cycle;
N    SAngl.Angl_K1 = Spec_mult (SAngl.Angl_K1, SAngl.Angl_K1);
N    int_long_mult ( (MaxFreq << 7), SAngl.Angl_K1);
X    int_long_mult ( (0x00001DCD65000000 << 7), SAngl.Angl_K1);
N    rez_mult = rez_mult / (int64)cycle;
N    SAngl.ASpeed_K1 = rez_mult / (int64)SAngl.Msht;
N    return;
N}
N////////////////////////////////////////////////////////////////////////////////
N//        
N////////////////////////////////////////////////////////////////////////////////
N
Nvoid init_angl_filter (void)
N{
N    SAngl.P = 9777563; // = (2*pi *5 / 6900) * 2^31
N    SAngl.PdivQ = 13827563; // = P / q, (q=sqrt(2)/2)
N    SAngl.Msht = 16; //
N    Set_koef_angl_filter (Func.cycle);
N    SAngl.last_cikl = Func.cycle;
N    return;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N//           
N////////////////////////////////////////////////////////////////////////////////
N
Nvoid Reset_angl_filter (void)
N{
N    SAngl.Z1 = 0;
N    SAngl.Angl_sp_out = 0;
N    SAngl.Z2 = tvg.SetAngl_temp * SAngl.Msht;
N    SAngl.Angl_fut = tvg.SetAngl_temp;
N    SAngl.Angl_filt = tvg.SetAngl_temp;
N    Set_koef_angl_filter (Func.cycle);
N    SAngl.last_cikl = Func.cycle;
N    return;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N//       
N////////////////////////////////////////////////////////////////////////////////
N
Nvoid angl_filter(int32 x)
N{
N    int32 tmf;
N    int32 tma;
N    int32 tmpi;
N    int64 tmps;
N//    const int32 int_8pi = 0x1921FB54; //8 pi
N
N    if (Func.cycle != SAngl.last_cikl)
N    {
N        SAngl.Z2 = SAngl.Last_Z2 + (SAngl.Z2 - SAngl.Last_Z2) * Func.cycle / SAngl.last_cikl;
N        Set_koef_angl_filter (Func.cycle);
N        SAngl.last_cikl = Func.cycle;
N    };
N    tmpi = int_pi2 * SAngl.Msht;
X    tmpi = 0x01921FB5 * SAngl.Msht;
N    SAngl.Last_Z2 = SAngl.Z2;
N
N    // 1 
N    tma = x * SAngl.Msht - SAngl.Z2;
N
N    //  
N    if (tma > tmpi)
N        tma -= tmpi * 2;
N    if (tma < -tmpi)
N        tma += tmpi * 2;
N
N    //   1 
N    tmf = Spec_mult(SAngl.Z1, SAngl.Angl_K0);
N    tmps = (int64)tmf + (int64)tma;
N
N    //   1 
N    if (tmps > c2v31_1)
X    if (tmps > 0x000000007FFFFFFF)
N        tmps = c2v31_1;
X        tmps = 0x000000007FFFFFFF;
N    if (tmps < -c2v31_1)
X    if (tmps < -0x000000007FFFFFFF)
N        tmps = -c2v31_1;
X        tmps = -0x000000007FFFFFFF;
N    SAngl.Z1 = (int32)tmps;
N
N    //   2 
N    tma = Spec_mult(SAngl.Z1, SAngl.Angl_K1);
N    tmf = tma + SAngl.Z2;
N
N    //  2 
N    if (tmf > tmpi)
N        tmf -= tmpi * 2;
N    if (tmf < -tmpi)
N        tmf += tmpi * 2;
N    SAngl.Z2 = tmf;
N    SAngl.Angl_filt = SAngl.Z2 / SAngl.Msht;
N
N    //   
N    tma = Spec_mult(SAngl.Z1, SAngl.ASpeed_K2) / SAngl.Msht;
N    tmf = tma + SAngl.Angl_filt;
N    //   
N    if (tmf > int_pi2)
X    if (tmf > 0x01921FB5)
N        tmf -= int_pi;
X        tmf -= 0x03243F6A;
N    if (tmf < -int_pi2)
X    if (tmf < -0x01921FB5)
N        tmf += int_pi;
X        tmf += 0x03243F6A;
N    SAngl.Angl_fut = tmf;
N
N    //   
N    int_long_mult ( SAngl.ASpeed_K1, SAngl.Z1);
N    SAngl.Angl_sp_out = rez_mult;
N
N    return;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N//   -    (x - , y - ,
N//  -   ,    2^32  )
N//   >0
N////////////////////////////////////////////////////////////////////////////////
Nint32 Spec_int_div (int32 x, int32 y)
N{
N    int64 tmpm,tmpn;
N	if ((x == 0) || (y == 0)) return 0;
N	if ((x > 0) && (x >= y)) return 0x7FFFFFFF;
N	if ((x < 0) && (-x > y))  return 0x80000000;
N	tmpm = x * c2v31; tmpn = y;
X	tmpm = x * 0x0000000080000000; tmpn = y;
N	tmpm = tmpm / tmpn;
N	return (int32)tmpm;
N}
N
N////////////////////////////////////////////////////////////////////////////////
N//   -    (x -  64 , y -  64 ,
N//  -   ,    2^32  )
N//   >0
N////////////////////////////////////////////////////////////////////////////////
Nint32 Spec_int64_div (int64 x, int64 y)
N{ 	int64 tmpx,tmpy;
N	int32 rez;
N	Uint32 tmx,tmy, bit;
N	tmpx = x; tmpy = y; tmx = 0; tmy = 0; rez = 0, bit = 0x40000000;
N	if ((x == 0) || (y == 0))  { return 0; };
N	if ((x > 0) && (x > y)) { return 0x7FFFFFFF; };
N	if (x < 0)
N	{
N		if (-x > y) { return 0x80000000; };
N		rez = 0x80000000; tmpx = -tmpx;
N	};
N	while (bit != 0)
N	{
N		tmy = tmy >> 1;
N		if ((tmpy & 0x00000001) != 0) {tmy += 0x80000000;  };
N		tmpy = tmpy >> 1;
N		if ((tmpx > tmpy) || ((tmpx == tmpy) && (tmx > tmy)))
N		{	tmpx -= tmpy;
N			if (tmx < tmy) { tmpx--; };
N			tmx -= tmy;
N			rez += bit;
N		};
N		bit = bit >> 1;
N	};
N	if ((rez & 0x80000000) != 0)
N	{ rez = rez & 0x7FFFFFFF; rez = -rez; };
N	return rez;
N}
N////////////////////////////////////////////////////////////////////////////////
N//       
N// : int32 (.. 2^31 = 1,  +-2^31  ,    , 1   
N// prec int32 - ,  "+",  1 ( ),  1024
N// :  int32 ugol (2^24 = 1 )  +-pi, . +-3,14*2^24
N////////////////////////////////////////////////////////////////////////////////
N
Nint32 CalcFullAngle (int32 sinx, int32 cosx)
N{
N    int32 abss, absc, ang;
N
N
N    if (sinx < 0) { abss = -sinx; } else { abss = sinx; };
N    if (cosx < 0) { absc = -cosx; } else { absc = cosx; };
N    //1, 5, 4, 8
N    if (abss < absc)
N    {
N        //1, 5
N        ang = int_arcsin (sinx, 1);
N        if (cosx < 0)
N        {
N            //4
N            if (sinx > 0) {ang = int_pi - ang; }
X            if (sinx > 0) {ang = 0x03243F6A - ang; }
N            //8
N            else {ang = -(int_pi + ang); };
X            else {ang = -(0x03243F6A + ang); };
N        };
N    }
N    else
N    // 2, 3, 6, 7
N    {
N        ang = int_arcsin (cosx, 1);
N        //2,3
N        if (sinx > 0) { ang = int_pi2 - ang; }
X        if (sinx > 0) { ang = 0x01921FB5 - ang; }
N        // 6,7
N        else {ang = -int_pi2 + ang; };
X        else {ang = -0x01921FB5 + ang; };
N    };
N    return ang;
N}
N////////////////////////////////////////////////////////////////////////////////
N
N
