L 1 "../MRAM_interface.c"
N/*
N * MRAM_interface.c
N */
N
N#define MRAM_INTERFACE_C_
N
N#include <stdint.h>
L 1 "C:/ti/ccs1010/ccs/tools/compiler/c6000_7.4.24/include/stdint.h" 1
N/*****************************************************************************/
N/* STDINT.H v7.4.24                                                          */
N/*                                                                           */
N/* Copyright (c) 2002-2018 Texas Instruments Incorporated                    */
N/* http://www.ti.com/                                                        */
N/*                                                                           */
N/*  Redistribution and  use in source  and binary forms, with  or without    */
N/*  modification,  are permitted provided  that the  following conditions    */
N/*  are met:                                                                 */
N/*                                                                           */
N/*     Redistributions  of source  code must  retain the  above copyright    */
N/*     notice, this list of conditions and the following disclaimer.         */
N/*                                                                           */
N/*     Redistributions in binary form  must reproduce the above copyright    */
N/*     notice, this  list of conditions  and the following  disclaimer in    */
N/*     the  documentation  and/or   other  materials  provided  with  the    */
N/*     distribution.                                                         */
N/*                                                                           */
N/*     Neither the  name of Texas Instruments Incorporated  nor the names    */
N/*     of its  contributors may  be used to  endorse or  promote products    */
N/*     derived  from   this  software  without   specific  prior  written    */
N/*     permission.                                                           */
N/*                                                                           */
N/*  THIS SOFTWARE  IS PROVIDED BY THE COPYRIGHT  HOLDERS AND CONTRIBUTORS    */
N/*  "AS IS"  AND ANY  EXPRESS OR IMPLIED  WARRANTIES, INCLUDING,  BUT NOT    */
N/*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR    */
N/*  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT    */
N/*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,    */
N/*  SPECIAL,  EXEMPLARY,  OR CONSEQUENTIAL  DAMAGES  (INCLUDING, BUT  NOT    */
N/*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,    */
N/*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY    */
N/*  THEORY OF  LIABILITY, WHETHER IN CONTRACT, STRICT  LIABILITY, OR TORT    */
N/*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE    */
N/*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.     */
N/*                                                                           */
N/*****************************************************************************/
N#ifndef _STDINT_H_
N#define _STDINT_H_
N
N/* 7.18.1.1 Exact-width integer types */
N
N    typedef   signed char   int8_t;
N    typedef unsigned char  uint8_t;
N    typedef          short  int16_t;
N    typedef unsigned short uint16_t;
N    typedef          int    int32_t;
N    typedef unsigned int   uint32_t;
N
N    typedef          __int40_t  int40_t;
N    typedef unsigned __int40_t uint40_t;
N
N    typedef          long long  int64_t;
N    typedef unsigned long long uint64_t;
N
N/* 7.18.1.2 Minimum-width integer types */
N
N    typedef  int8_t   int_least8_t;
N    typedef uint8_t  uint_least8_t;
N
N    typedef  int16_t  int_least16_t;
N    typedef uint16_t uint_least16_t;
N    typedef  int32_t  int_least32_t;
N    typedef uint32_t uint_least32_t;
N
N    typedef  int40_t  int_least40_t;
N    typedef uint40_t uint_least40_t;
N
N    typedef  int64_t  int_least64_t;
N    typedef uint64_t uint_least64_t;
N
N/* 7.18.1.3 Fastest minimum-width integer types */
N
N    typedef  int32_t  int_fast8_t;
N    typedef uint32_t uint_fast8_t;
N    typedef  int32_t  int_fast16_t;
N    typedef uint32_t uint_fast16_t;
N
N    typedef  int32_t  int_fast32_t;
N    typedef uint32_t uint_fast32_t;
N
N    typedef  int40_t  int_fast40_t;
N    typedef uint40_t uint_fast40_t;
N
N    typedef  int64_t  int_fast64_t;
N    typedef uint64_t uint_fast64_t;
N
N/* 7.18.1.4 Integer types capable of holding object pointers */
N    typedef          int intptr_t;
N    typedef unsigned int uintptr_t;
N
N/* 7.18.1.5 Greatest-width integer types */
N    typedef          long long intmax_t;
N    typedef unsigned long long uintmax_t;
N
N/* 
N   According to footnotes in the 1999 C standard, "C++ implementations
N   should define these macros only when __STDC_LIMIT_MACROS is defined
N   before <stdint.h> is included." 
N*/
N#if !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS)
X#if !0L || 0L
N
N/* 7.18.2 Limits of specified width integer types */
N
N    #define  INT8_MAX   0x7f
N    #define  INT8_MIN   (-INT8_MAX-1)
N    #define UINT8_MAX   0xff
N
N    #define  INT16_MAX  0x7fff
N    #define  INT16_MIN  (-INT16_MAX-1)
N    #define UINT16_MAX  0xffff
N
N    #define  INT32_MAX  0x7fffffff
N    #define  INT32_MIN  (-INT32_MAX-1)
N    #define UINT32_MAX  0xffffffff
N
N    #define  INT40_MAX  0x7fffffffff
N    #define  INT40_MIN  (-INT40_MAX-1)
N    #define UINT40_MAX  0xffffffffff
N
N    #define  INT64_MAX  0x7fffffffffffffff
N    #define  INT64_MIN  (-INT64_MAX-1)
N    #define UINT64_MAX  0xffffffffffffffff
N
N    #define  INT_LEAST8_MAX   (INT8_MAX)
N    #define  INT_LEAST8_MIN   (INT8_MIN)
N    #define UINT_LEAST8_MAX   (UINT8_MAX)
N
N    #define  INT_LEAST16_MAX  (INT16_MAX)
N    #define  INT_LEAST16_MIN  (INT16_MIN)
N    #define UINT_LEAST16_MAX  (UINT16_MAX)
N    #define  INT_LEAST32_MAX  (INT32_MAX)
N    #define  INT_LEAST32_MIN  (INT32_MIN)
N    #define UINT_LEAST32_MAX  (UINT32_MAX)
N
N    #define  INT_LEAST40_MAX  (INT40_MAX)
N    #define  INT_LEAST40_MIN  (INT40_MIN)
N    #define UINT_LEAST40_MAX  (UINT40_MAX)
N
N    #define  INT_LEAST64_MAX  (INT64_MAX)
N    #define  INT_LEAST64_MIN  (INT64_MIN)
N    #define UINT_LEAST64_MAX  (UINT64_MAX)
N
N    #define  INT_FAST8_MAX   (INT32_MAX)
N    #define  INT_FAST8_MIN   (INT32_MIN)
N    #define UINT_FAST8_MAX   (UINT32_MAX)
N    #define  INT_FAST16_MAX  (INT32_MAX)
N    #define  INT_FAST16_MIN  (INT32_MIN)
N    #define UINT_FAST16_MAX  (UINT32_MAX)
N
N    #define  INT_FAST32_MAX  (INT32_MAX)
N    #define  INT_FAST32_MIN  (INT32_MIN)
N    #define UINT_FAST32_MAX  (UINT32_MAX)
N
N    #define  INT_FAST40_MAX  (INT40_MAX)
N    #define  INT_FAST40_MIN  (INT40_MIN)
N    #define UINT_FAST40_MAX  (UINT40_MAX)
N
N    #define  INT_FAST64_MAX  (INT64_MAX)
N    #define  INT_FAST64_MIN  (INT64_MIN)
N    #define UINT_FAST64_MAX  (UINT64_MAX)
N
N    #define INTPTR_MAX   (INT32_MAX)
N    #define INTPTR_MIN   (INT32_MIN)
N    #define UINTPTR_MAX  (UINT32_MAX)
N
N    #define INTMAX_MIN   (INT64_MIN)
N    #define INTMAX_MAX   (INT64_MAX)
N    #define UINTMAX_MAX  (UINT64_MAX)
N
N/* 7.18.3 Limits of other integer types */
N
N    #define PTRDIFF_MAX (INT32_MAX)
N    #define PTRDIFF_MIN (INT32_MIN)
N
N    #define SIG_ATOMIC_MIN (INT32_MIN)
N    #define SIG_ATOMIC_MAX (INT32_MAX)
N
N    #define SIZE_MAX (UINT32_MAX)
N
N#ifndef WCHAR_MAX
N#if !defined(__TI_WCHAR_T_BITS__) || __TI_WCHAR_T_BITS__ == 16
X#if !1L || 16 == 16
N#define WCHAR_MAX 0xffffu
N#else 
S#define WCHAR_MAX 0xffffffffu
N#endif
N#endif
N
N#ifndef WCHAR_MIN
N#define WCHAR_MIN 0
N#endif
N
N    #define WINT_MIN (INT32_MIN)
N    #define WINT_MAX (INT32_MAX)
N
N/* 7.18.4.1 Macros for minimum-width integer constants */
N
N/*
N   There is a defect report filed against the C99 standard concerning how 
N   the (U)INTN_C macros should be implemented.  Please refer to --
N   http://wwwold.dkuug.dk/JTC1/SC22/WG14/www/docs/dr_209.htm 
N   for more information.  These macros are implemented according to the
N   suggestion given at this web site.
N*/
N
N    #define  INT8_C(value)  ((int_least8_t)(value))
N    #define UINT8_C(value)  ((uint_least8_t)(value))
N    #define  INT16_C(value) ((int_least16_t)(value))
N    #define UINT16_C(value) ((uint_least16_t)(value))
N    #define  INT32_C(value) ((int_least32_t)(value))
N    #define UINT32_C(value) ((uint_least32_t)(value))
N
N    #define  INT40_C(value) ((int_least40_t)(value))
N    #define UINT40_C(value) ((uint_least40_t)(value))
N
N    #define  INT64_C(value) ((int_least64_t)(value))
N    #define UINT64_C(value) ((uint_least64_t)(value))
N
N/* 7.18.4.2 Macros for greatest-width integer constants */
N
N    #define  INTMAX_C(value) ((intmax_t)(value))
N    #define UINTMAX_C(value) ((uintmax_t)(value))
N
N#endif /* !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS) */
N
N#endif /* _STDINT_H_ */
L 8 "../MRAM_interface.c" 2
N#include <emif.h>
L 1 "E:/TI_workspase/c6701_t/emif.h" 1
N/*
N * emif.h
N *
N *  Created on: 15 . 2020 .
N *      Author: Anton
N */
N
N#ifndef EMIF_H_
N#define EMIF_H_
N
N#define start_adr_MRAM      0x01400000
N#define start_adr_FPGA      0x02000000
N#define lenght_MRAM         0x01000000
N#define lenght_FPGA         0x00400000
N
N
Nvoid emif_config();
Nvoid read_MRAM_data (uint32_t adr_MRAM, uint32_t *p, uint32_t lenght);
Nvoid write_MRAM_data (uint32_t adr_MRAM, uint32_t *p, uint32_t lenght);
N
N#endif /* EMIF_H_ */
L 9 "../MRAM_interface.c" 2
N#include "MRAM_interface.h"
L 1 "..\MRAM_interface.h" 1
N/*
N * MRAM_interface.h
N */
N
N#ifndef HEADER_MRAM_INTERFACE_H_
N#define HEADER_MRAM_INTERFACE_H_
N
N#include "myTypes.h"
L 1 "..\myTypes.h" 1
N/*
N * myTypes.h
N */
N
N#ifndef MYTYPES_H_
N#define MYTYPES_H_
N
N/* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
N
Ntypedef unsigned long long	Uint64;
N
N/* Signed integer definitions (32bit, 16bit, 8bit) follow... */
Ntypedef long long			Int64;
N
Ntypedef unsigned long long  uint64;
Ntypedef unsigned int        Uint32;
Ntypedef unsigned int        uint32;
Ntypedef unsigned short      uint16;
Ntypedef unsigned short      Uint16;
Ntypedef unsigned char       uint8;
N
N/* Signed integer definitions (32bit, 16bit, 8bit) follow... */
Ntypedef long long           int64;
Ntypedef int                 int32;
Ntypedef short               int16;
Ntypedef char                int8;
N
N
N
Ntypedef float				Float32;
Ntypedef double				Float64;
N
N/* Constants */
N#ifndef TRUE
N#define TRUE				((Bool) 1)
N#endif
N
N#ifndef FALSE
N#define FALSE				((Bool) 0)
N#endif
N
N#ifndef NULL
N#define NULL    			((void*) 0 )
N#endif
N
N#endif /* MYTYPES_H_ */
L 9 "..\MRAM_interface.h" 2
N
Nvoid InitAddres(void);
N
N
N#endif /* HEADER_MRAM_INTERFACE_H_ */
L 10 "../MRAM_interface.c" 2
N#include "Address_variable_data.h"
L 1 "..\Address_variable_data.h" 1
N#ifndef HEADER_ADRESS_VARIABLE_DATA_H_
N#define HEADER_ADRESS_VARIABLE_DATA_H_
N
N#include <myTypes.h>
Nextern Uint32 table_address_variable [256];
Nextern uint8 table_type_variable [256];
N
N
N#endif /* HEADER_ADRESS_VARIABLE_DATA_H_ */
L 11 "../MRAM_interface.c" 2
N
NUint32 Table_variable [112] = {
N    0xFFFFFFFF,            // 0  .
N    2000,                  // 1   
N    528911478,             // 2     .
N    2252,                  // 3      
N    0xFFFFFFFF,            // 4  .
N    0xFFFFFFFF,            // 5  .
N    0xFFFFFFFF,            // 6  .
N    0xFFFFFFFF,            // 7  .
N    0xFFFFFFFF,            // 8  .
N    0xFFFFFFFF,            // 9  .
N    //adr_10
N    0xFFFFFFFF,            // 10  .
N    0xFFFFFFFF,            // 11  .
N    0xFFFFFFFF,            // 12  .
N    0xFFFFFFFF,            // 13  .
N    0xFFFFFFFF,            // 14  .
N    0xFFFFFFFF,            // 15  .
N    0xFFFFFFFF,            // 16  .
N    0xFFFFFFFF,            // 17  .
N    0xFFFFFFFF,            // 18  .
N    0xFFFFFFFF,            // 19  .
N    //adr_20
N    0xFFFFFFFF,            // 20  .
N    0xFFFFFFFF,            // 21  .
N    0xFFFFFFFF,            // 22  .
N    0xFFFFFFFF,            // 23  .
N    0xFFFFFFFF,            // 24  .
N    0xFFFFFFFF,            // 25  .
N    0xFFFFFFFF,            // 26  .
N    0xFFFFFFFF,            // 27  .
N    0xFFFFFFFF,            // 28  .
N    0xFFFFFFFF,            // 29  .
N    //adr_30
N    0xFFFFFFFF,            // 30  .
N    0xFFFFFFFF,            // 31  .
N    0xFFFFFFFF,            // 32  .
N    //    
N    0,                     // 33   0  
N    0,                     // 34 . .  0  
N    139420237,             // 35  .
N    0,                     // 36 .   
N    0,                     // 37 . .  0     
N    0,                     // 38 .      
N    1368859,               // 39     
N
N   //adr_40
N    622770257,             // 40   (       )
N    0xFFFFFFFF,            // 41  .
N    1171270,               // 42     a0  
N    9777563,               // 43  Wcp / F0 -     
N    13827563,              // 44 P / q -   ,   
N    16,                    // 45     
N    0xFFFFFFFF,            // 46  ,
N    0xFFFFFFFF,            // 47  ,
N    0xFFFFFFFF,            // 48  ,
N    0xFFFFFFFF,            // 49  ,
N
N    //adr_50
N    //      
N    275000,                // 50 ,  -      
N    365,                   // 51 ,         
N    //      
N    91000,                 // 52 ,  -      -
N    40,                    // 53 ,         
N    //   
N    2200000,               // 54 ,   
N    0xFFFFFFFF,            // 55  ,
N    200000,                // 56    
N    0xFFFFFFFF,            // 57  ,
N    0xFFFFFFFF,            // 58  ,
N    56295,                 // 59   ,   0,2
N
N    //adr_60
N    //  
N    5000000,               // 60 ,  -   
N    100,                   // 61 ,      
N    1517813760,            // 62      (max 23160 *65536)
N    32704,                 // 63     PWM (max 1022 *32)
N    //   A
N    1517813760,            // 64 ,      
N    16000000,              // 65     (1%   ),
N    21474836,              // 66    
N    0x7EB851EB,            // 67    -  (0,99   ),
N    0x19999999,            // 68    -  (0,2   ),
N    0x06666666,            // 69      (0,05   )
N
N    //adr_70
N    //  
N    2400000,               // 70 ,     
N    60,                    // 71 ,      
N    0xFFFFFFFF,            // 72  ,
N    1517813760,            // 73     
N    //   
N    1517813760,            // 74 ,      
N    0xFFFFFFFF,            // 75 ,     
N    21474836,              // 76    
N    0xFFFFFFFF,            // 77  ,
N    0xFFFFFFFF,            // 78  ,
N    0xFFFFFFFF,            // 79  ,
N
N    //adr_80
N    //  
N    2443000,               // 80 ,     
N    174,                   // 81 ,      
N    0xFFFFFFFF,            // 82  ,
N    0xFFFFFFFF,            // 83  ,
N    //   
N    1517813760,            // 84 ,      
N    0xFFFFFFFF,            // 85  ,
N    2928,                  // 86    
N    0xFFFFFFFF,            // 87  ,
N    0xFFFFFFFF,            // 88  ,
N    0xFFFFFFFF,            // 89  ,
N
N    //adr_90
N    68442950,              // 90       
N    6844295,               // 91     
N    0xFFFFFFFF,            // 92  .
N    10,                    // 93 N0   
N    0x00010001,            // 94    = (nX+(nY<<16))
N    586653813,             // 95       
N    117330762,             // 96       
N    6844295,               // 97    
N    214748364,             // 98   
N    0xFFFFFFFF,            // 99  ,
N
N    //adr_100
N    292817,               // 100      /  
N    56220990,             // 101        / 
N    29281,                // 102     /  ,
N    3748066,              // 103      /  
N    1599995904,           // 104   
N    0xFFFFFFFF,           // 105  ,
N    0xFFFFFFFF,           // 106  ,
N    0xFFFFFFFF,           // 107  ,
N    0xFFFFFFFF,           // 108  ,
N    0xFFFFFFFF,           // 109  ,
N    0xFFFFFFFF,           // 110  ,
N    0xFFFFFFFF,           // 111  ,
N};
N
N
Nvoid InitAddres(void)
N{
N    uint32  *p, i;
N    for (i = 0; i < 112; i++)
N    {
N        if (table_address_variable[i] != 0xFFFFFFFF)
N        {
N            p = (uint32*)table_address_variable[i];
N            *p = Table_variable[i];
N        };
N    };
N    return;
N}
N
