#ifndef RAM_H_
#define RAM_H_

#include "myTypes.h"


#define wrong		0xFFFF
#define wronglong	0xFFFFFFFF
#define LENBUF 1000 
enum typereg
{
	nothing,
	rawplis,
	startmaxtime,
	stopmaxtime,
	startevent,
	stopevent,
	pending,
	finish
};
enum typeevent
{
	space,
	onemore,
	oneless,
	fourmore,
	fourless
};

typedef union r_s
{
	struct
	{
		Uint16  regtype;
		Uint16  eventtype;
		float threshold;
		Uint16 adress[4];
	}reg;
	Uint16 arr[8];
}ssp;

typedef struct kolco_s
{
    Uint32* p1;
    Uint32* p2;
    Uint32* p3;
    Uint32* p4;
    int stop;
    int index;
    char flag;
}kolco;
void initbuf();
void initssp(Uint16* arr);
void rawservice();
void putpoint(Uint32 par1,Uint32 par2,Uint32 par3,Uint32 par4);
void getpoints();

//   ------
//Uint16 returnadress(void* val);
//int WriteRamAnyWords(Uint16 adr, Uint16* buf, Uint16 cnt);
int SetBuferAnswer(Uint16 adr, Uint16 c);

#endif /*RAM_H_*/
