#include <c6x.h>
#include <csl.h>
#include <csl_irq.h>
#include <csl_irqhal.h>
#include <FPGA_interface.h>
#include <mcbsp_recv_slave.h>
#include <Timers.h>
uint32_t ext4_counter = 0;

void INIT_interrupt (void)
{
    //IRQ_nmiDisable();
    //IRQ_resetAll();
    IRQ_setVecs(0);
//
//    IRQ_RSET(   MUXL,   IRQ_MUXL_INTSEL4_DEFAULT);
  //  IRQ_RSET( EXTPOL, 0);


    IRQ_nmiEnable();

//    IER |= 0x10;
    IER |= 0x3;
    IRQ_globalEnable();
}

interrupt void TINT1_ISR (void)
{
    IRQ_clear(IRQ_EVT_TINT1);
}

//INT4 INTSEL4 0 0100b EXT_INT4 External interrupt pin 4
interrupt void INT4_ISR()
{
    IRQ_clear(IRQ_EVT_EXTINT4);
    // FPGA interrupt. Need readout
//    tvgISR ();
//    ext4_counter += 1;  // DEBUG
}

//INT5 INTSEL5 0 0101b EXT_INT5 External interrupt pin 5
interrupt void INT5_ISR()
{
    IRQ_clear(IRQ_EVT_EXTINT5);

}

//INT6 INTSEL6 0 0110b EXT_INT6 External interrupt pin 6
interrupt void INT6_ISR()
{
    IRQ_clear(IRQ_EVT_EXTINT6);

}

//INT7 INTSEL7 0 0111b EXT_INT7 External interrupt pin 7
interrupt void INT7_ISR()
{
    IRQ_clear(IRQ_EVT_EXTINT7);

}
#define RX_DMA 1
#define TX_DMA 0
//INT8 INTSEL8 0 1000b DMA_INT0 DMA Channel 0 Interrupt
interrupt void INT8_ISR()
{
//    dma_compl(RX_DMA);
    IRQ_clear(IRQ_EVT_DMAINT0);

}

//INT9 INTSEL9 0 1001b DMA_INT1 DMA Channel 1 interrupt
interrupt void INT9_ISR()
{
    IRQ_clear(IRQ_EVT_DMAINT1);
//    c_int09();
}

//INT10 INTSEL10 0 0011b SD_INT EMIF SDRAM timer interrupt
interrupt void INT10_ISR()
{
    IRQ_clear(IRQ_EVT_TINT0);

}

//INT11 INTSEL11 0 1010b DMA_INT2 DMA Channel 2 interrupt
interrupt void INT11_ISR()
{
    IRQ_clear(IRQ_EVT_DMAINT2);
//    c_int10();
}

//INT12 INTSEL12 0 1011b DMA_INT3 DMA Channel 3 interrupt
interrupt void INT12_ISR()
{
    IRQ_clear(IRQ_EVT_DMAINT3);

}

interrupt void INT13_ISR()
{
    IRQ_clear(IRQ_EVT_TINT0);

}

/*!
 * XINT (FSX) irq
 */
interrupt void INT14_ISR()
{
//    Tims.CurVPITim = TIMER_getCount(Timer0);
//    fsx_irq(1);
}

/*!
 *  Rx SPI irq
 */
interrupt void INT15_ISR()
{
    IRQ_clear(IRQ_EVT_RINT1);

}
