/*
 * System_output_information.h
 */

#ifndef HEADER_SYSTEM_OUTPUT_INFORMATION_H_
#define HEADER_SYSTEM_OUTPUT_INFORMATION_H_
#include <Functions.h>
typedef struct//  
{
    int32 ampl;
    int32 angl;
    int32 cfree; //    (1 /, ) (161)
    int32 cdus; //   (1 /, ) (160)
    int32 csovm; //     () (162)
    int32 acsel; //   () (163)
    InFLTR_s FiltrOut; //   
    InFLTR_s FiltrR; //   
    InFLTR_s FiltrQ; //   
    uint8 VarAdr[16];
    uint8 VarTipe[16];
    int32 OutFiltrKoef; //    
    int32 RQFiltrKoef; //     
    int32 SumAngl;
    uint32 SumTim;
    uint64 SumTimLong;
    uint32 deltaTim;
    int32 deltaAngl;
    int32 RegAns[3];
}   OutInfo_s;

typedef struct//  
{
    Uint32 outflag;// -   sysflag   system_flags_s
    int32 outsumangl;// ,    (0,00025 .)
    int32 outspeed;//  (Na    , 0,001./)
    Uint32 outtime;//   () ( )
    Uint32 outdeltatime;//    (    ( )
    int32 outampl;// ,   R0
    int32 outquad;// 
    int32 outangl;//   (  * 2:24 )
    Uint32 outfreq;// , 
    Uint32 variables[16];// 
}   OutInfoVPI_s;




#endif /* HEADER_SYSTEM_OUTPUT_INFORMATION_H_ */
