/*
 * Timers.c
 *
 *  Created on: 9 . 2020 .
 *      Author: user62
 */
#include <c6x.h>
#include <csl.h> /* CSL library */
#include <csl_legacy.h>
#include <csl_timer.h>
#include <csl_timerhal.h>

#include "Timers.h"
#include "Main.h"
#include "System_unit.h"

TIMER_Handle Timer0, Timer1;
TIMER_Config Tim0, Tim1;
const Uint32 T100ms = 3500000; // (CPUCLOCK/4)*100e-3
const Uint32 T100mks = 7000; // (CPUCLOCK/4)*100e-6 * 2
Uint32 Time0, Time1, HTime;
Time_S Tims;
//Uint32 TimeFlags, ProgTimeCount[32]; //        
//     Program_Flag   
Uint32 MaskProgFlag[32];//TODO = { flagTochGot_mask }; //, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

void init_timers()
{

    // TIMER 0
    Timer0 = TIMER_open(TIMER_DEV0, TIMER_OPEN_RESET);
    /* Create Timer Control Register field */
    Tim0.ctl = TIMER_CTL_RMK(TIMER_CTL_INVINP_NO,
                            TIMER_CTL_CLKSRC_CPUOVR4,
                            TIMER_CTL_CP_PULSE,
                            TIMER_CTL_HLD_NO,
                            TIMER_CTL_GO_YES,
                            TIMER_CTL_PWID_ONE,
                            TIMER_CTL_DATOUT_1,
                            TIMER_CTL_INVOUT_NO,
                            TIMER_CTL_FUNC_GPIO  ); //invinp,clksrc,cp,hld,go,pwid,datout,invout,func
    Tim0.prd = T100ms;
    Tim0.cnt = 0;
    TIMER_config(Timer0, &Tim0);
    TIMER_setDatOut(Timer0, 0);
    TIMER_start(Timer0);
    HTime = 0;

    Timer1 = TIMER_open(TIMER_DEV1, TIMER_OPEN_RESET);
    /* Create Timer Control Register field */
    Tim1.ctl = TIMER_CTL_RMK(TIMER_CTL_INVINP_NO,
                             TIMER_CTL_CLKSRC_CPUOVR4,
                            TIMER_CTL_CP_PULSE,
                            TIMER_CTL_HLD_YES,
                            TIMER_CTL_GO_NO,
                            TIMER_CTL_PWID_ONE,
                            TIMER_CTL_DATOUT_0,
                            TIMER_CTL_INVOUT_NO,
                            TIMER_CTL_FUNC_GPIO  ); //invinp,clksrc,cp,hld,go,pwid,datout,invout,func
    Tim1.prd = T100mks;
    Tim1.cnt = 0;
    TIMER_config(Timer1, &Tim1);
    TIMER_setDatOut(Timer1, 0);
    TIMER_pause(Timer1);
//    TimeFlags = 0;  HTime = 0;
    return;
}


void setReset(int v)
{
    TIMER_setDatOut(Timer1, v);
}

interrupt void TINT0_ISR (void) //   ,    
{
//    int i;
//    Uint32 mask;
//
//    IRQ_clear(IRQ_EVT_TINT0);
//
//    HTime++;
//    i = 0; mask = 1;
//    while ((TimeFlags != 0)  &&  (mask != 0))
//    {
//        if ((mask & TimeFlags) != 0)
//        {
//           if (HTime ==  ProgTimeCount[i])
//           {
//               //TODO: Program_Flag = Program_Flag | MaskProgFlag[i];
//               TimeFlags = TimeFlags & (!(mask));
//           };
//        };
//        i++; mask = mask << 1;
//    };
    return;
}
/*!   0
 * n -   ( Program_Flag)         MaskProgFlag
 *
 */
//
//
// DeltaT -      100 
////////////////////////////////////////////////////////////////////////////////
/*!
 *
 */
void SetTim0 (int n, Uint32 DeltaT)
{
//    Uint32 mask;
//
//    if ((n < 32) || (n >= 0))
//    {
//        ProgTimeCount[n] = HTime + DeltaT;
//        mask = 1;
//        while (n > 0)
//        {
//            mask = mask << 1; n--;
//        };
//        TimeFlags |= mask;
//   };
   return;
}
////////////////////////////////////////////////////////////////////////////////
