/*
 * Timers.h
 *
 *  Created on: 9 . 2020 .
 *      Author: user62
 */

#ifndef HEADER_TIMERS_H_
#define HEADER_TIMERS_H_

#include <c6x.h>
#include <csl.h> /* CSL library */
#include <csl_legacy.h>
#include <csl_timer.h>
#include <csl_timerhal.h>


#include "Main.h"
#include "System_unit.h"
#include "myTypes.h"

typedef struct//  
{
    Uint32 CurFPGATim;
    Uint32 LastFPGATim;
    Uint32 CurVPITim;
    Uint32 LastVPINim;
    Uint32 CiklFPGA;
    int32 PoprFPGA;
    int Period;
    InFLTR_s FiltrCikle, FiltrPopr; //   
} Time_S;

void init_timers();
static void Tim0ISR (void);  //   0
void SetTim0 (int n, Uint32 DeltaT);
void setReset(int v);
extern Time_S Tims;
extern TIMER_Handle Timer0;
extern TIMER_Handle Timer1;
extern Uint32 HTime;


#endif /* HEADER_TIMERS_H_ */
