/******************************************************************************\
*           Copyright (C) 2000 Texas Instruments Incorporated.
*                           All Rights Reserved
*------------------------------------------------------------------------------
* FILENAME...... csl_utop.c
* DATE CREATED.. 07/19/2000 
* LAST MODIFIED. 10/09/2000 
\******************************************************************************/
#define _UTOP_MOD_
#include "csl_utop.h"


#if (UTOP_SUPPORT)
/******************************************************************************\
*                         L O C A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* static macro declarations
\******************************************************************************/


/******************************************************************************\
* static typedef declarations
\******************************************************************************/


/******************************************************************************\
* static function declarations
\******************************************************************************/


/******************************************************************************\
* static variable definitions
\******************************************************************************/


/******************************************************************************\
* static function definitions
\******************************************************************************/


/******************************************************************************\
*                        G L O B A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* global variable definitions
\******************************************************************************/


/******************************************************************************\
* global function definitions
\******************************************************************************/
/*----------------------------------------------------------------------------*/
void UTOP_reset() {

  Uint32 gie;

  gie = IRQ_globalDisable();

  UTOP_RSET(UCR,   UTOP_UCR_DEFAULT);
  UTOP_RSET(UIER,  UTOP_UIER_DEFAULT);
  UTOP_RSET(UIPR,  0xFFFFFFFF);
  UTOP_RSET(CDR,   UTOP_CDR_DEFAULT);
  UTOP_RSET(EIER,  UTOP_EIER_DEFAULT);
  UTOP_RSET(EIPR,  0xFFFFFFFF);

  IRQ_disable(IRQ_EVT_UINT);
  IRQ_clear(IRQ_EVT_UINT);

  IRQ_globalRestore(gie);

  return;
}

/*----------------------------------------------------------------------------*/


#endif /* UTOP_SUPPORT */
/******************************************************************************\
* End of csl_utop.c
\******************************************************************************/

