L 1 "../csl/csl_emu.c"
N/**************************************************************************\
N*              Copyright (C) 2002 Texas Instruments Incorporated.
X
N*                             All Rights Reserved
N*--------------------------------------------------------------------------
N* MODULE NAME... EMU
N* FILENAME...... csl_emu.c
N* DATE CREATED.. 05/12/2003
N* LAST MODIFIED. 05/20/2003
N* PROJECT....... Chip Support Library
N* COMPONENT..... Service Layer
N* PREREQUISITES.
N\**************************************************************************/
N
N/**************************************************************************\
N* Private Macro and Include files
X
N\**************************************************************************/
N#define _EMU_MOD_
N
N#include <csl_emu.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_emu.h" 1
N/**************************************************************************\
N*              Copyright (C) 2002 Texas Instruments Incorporated.
X
N*                             All Rights Reserved
N*--------------------------------------------------------------------------
N* MODULE NAME... EMU
N* FILENAME...... csl_emu.h
N* DATE CREATED.. 05/12/2003
N* LAST MODIFIED. 05/20/2003
N* PROJECT....... Chip Support Library
N* COMPONENT..... Service Layer
N* PREREQUISITES.
N\**************************************************************************/
N/**************************************************************************\
N* Private Macros - Include files - EMU_SUPPORT
X
N\**************************************************************************/
N#ifndef _CSL_EMU_H_
N#define _CSL_EMU_H_
N
N#include <csl_stdinc.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinc.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 10/03/2000
N*                01/06/2005    Added _TI_STD_TYPES  directive to protect 
N*                              multiple definition of datatypes.
N\******************************************************************************/
N#ifndef _CSL_STDINC_H_
N#define _CSL_STDINC_H_
N
N#include <csl_stdinchal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_stdinchal.h" 1
N/******************************************************************************\
N*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_stdinchal.h
N* DATE CREATED.. 03/11/1999 
N* LAST MODIFIED. 03/23/2001
N\******************************************************************************/
N#ifndef _CSL_STDINCHAL_H_
N#define _CSL_STDINCHAL_H_
N
N
N/******************************************************************************\
N* HAL macro definitions
X
N\******************************************************************************/
N
N  #define _VALUEOF(x) ((Uint32)(x))
N
N  /*******************************************************/
N  /* generic macros for field manipulation               */
N  /*******************************************************/
N
N  #define _PER_FSHIFT(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_SHIFT
X  #define _PER_FSHIFT(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_SHIFT
N
N  #define _PER_FMASK(PER,REG,FIELD) \
N    _##PER##_##REG##_##FIELD##_MASK
X  #define _PER_FMASK(PER,REG,FIELD)     _##PER##_##REG##_##FIELD##_MASK
N
N  #define _PER_FSYM(PER,REG,FIELD,SYM)\
N    PER##_##REG##_##FIELD##_##SYM
X  #define _PER_FSYM(PER,REG,FIELD,SYM)    PER##_##REG##_##FIELD##_##SYM
N
N  #define _PER_FDEFAULT(PER,REG,FIELD) \
N    ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT) \
N    & _##PER##_##REG##_##FIELD##_MASK)
X  #define _PER_FDEFAULT(PER,REG,FIELD)     ((##PER##_##REG##_##FIELD##_DEFAULT << _##PER##_##REG##_##FIELD##_SHIFT)     & _##PER##_##REG##_##FIELD##_MASK)
N
N  #define _PER_FMK(PER,REG,FIELD,x) (\
N    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMK(PER,REG,FIELD,x) (    (((Uint32)(x))<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FMKS(PER,REG,FIELD,SYM) (\
N    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)\
N  )
X  #define _PER_FMKS(PER,REG,FIELD,SYM) (    (_PER_FSYM(##PER,##REG,##FIELD,##SYM)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)  )
N
N  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(\
N    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))\
N    >>_PER_FSHIFT(##PER,##REG,##FIELD))\
N  )
X  #define _PER_FEXTRACT(PER,REG,FIELD,reg) (Uint32)(    (((Uint32)(reg)&_PER_FMASK(##PER,##REG,##FIELD))    >>_PER_FSHIFT(##PER,##REG,##FIELD))  )
N
N  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(\
N    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|\
N    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))\
N    &_PER_FMASK(##PER,##REG,##FIELD)))\
N  )
X  #define _PER_FINSERT(PER,REG,FIELD,reg,field) (Uint32)(    (((Uint32)(reg)&~_PER_FMASK(##PER,##REG,##FIELD))|    (((Uint32)(field)<<_PER_FSHIFT(##PER,##REG,##FIELD))    &_PER_FMASK(##PER,##REG,##FIELD)))  )
N
N  /*******************************************************/
N  /* macros for memmory mapped registers                 */
N  /*******************************************************/
N
N  #define _PER_RAOI(addr,PER,REG,and,or,inv)\
N    (*(volatile Uint32*)(addr))=(\
N      ((((*(volatile Uint32*)(addr))\
N      &((Uint32)(and)))\
N      |((Uint32)(or)))\
N      ^((Uint32)(inv)))\
N    )
X  #define _PER_RAOI(addr,PER,REG,and,or,inv)    (*(volatile Uint32*)(addr))=(      ((((*(volatile Uint32*)(addr))      &((Uint32)(and)))      |((Uint32)(or)))      ^((Uint32)(inv)))    )
N
N  #define _PER_RGET(addr,PER,REG) \
N    (*(volatile Uint32*)(addr))
X  #define _PER_RGET(addr,PER,REG)     (*(volatile Uint32*)(addr))
N
N  #define _PER_RSET(addr,PER,REG,x) \
N    (*(volatile Uint32*)(addr))=((Uint32)(x))
X  #define _PER_RSET(addr,PER,REG,x)     (*(volatile Uint32*)(addr))=((Uint32)(x))
N
N  #define _PER_FGET(addr,PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
X  #define _PER_FGET(addr,PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG))
N
N  #define _PER_FSET(addr,PER,REG,FIELD,field)\
N    _PER_RSET(addr,##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
X  #define _PER_FSET(addr,PER,REG,FIELD,field)    _PER_RSET(addr,##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),field))
N
N  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)\
N    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_FSETS(addr,PER,REG,FIELD,SYM)    _PER_RSET(addr,##PER,##REG,_PER_FINSERT(##PER,##REG,##FIELD,_PER_RGET(addr,##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N  /*******************************************************/
N  /* macros for CPU control registers                    */
N  /*******************************************************/
N
N  #define _PER_CRGET(PER,REG) \
N    REG
X  #define _PER_CRGET(PER,REG)     REG
N
N  #define _PER_CRSET(PER,REG,reg) \
N    REG=((Uint32)(reg))
X  #define _PER_CRSET(PER,REG,reg)     REG=((Uint32)(reg))
N
N  #define _PER_CFGET(PER,REG,FIELD) \
N    _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
X  #define _PER_CFGET(PER,REG,FIELD)     _PER_FEXTRACT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG))
N
N  #define _PER_CFSET(PER,REG,FIELD,field)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
X  #define _PER_CFSET(PER,REG,FIELD,field)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,##FIELD,_PER_CRGET(##PER,##REG),field))
N
N  #define _PER_CFSETS(PER,REG,FIELD,SYM)\
N    _PER_CRSET(##PER,##REG,\
N    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),\
N    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
X  #define _PER_CFSETS(PER,REG,FIELD,SYM)    _PER_CRSET(##PER,##REG,    _PER_FINSERT(##PER,##REG,FIELD,_PER_CRGET(##PER,##REG),    _PER_FSYM(##PER,##REG,##FIELD,##SYM)))
N
N/*----------------------------------------------------------------------------*/
N
N#endif /* _CSL_STDINCHAL_H_ */
N/******************************************************************************\
N* End of csl_stdinchal.h
X
N\******************************************************************************/
N
L 15 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N
N/******************************************************************************\
N* macro declarations
X
N\******************************************************************************/
N
N/* a few standard constants */
N#ifndef TRUE
N  #define TRUE   1
N#endif
N#ifndef FALSE
N  #define FALSE  0
N#endif
N
N/* Invalid Pointer                                               */
N/* In many instances, it is better to use INV as opposed to NULL */
N/* because 0 may actually be a valid pointer                     */
N#ifndef INV
N  #define INV    ((void*)(-1))
N#endif
N
N#ifndef UNREFERENCED_PARAMETER
N  #define UNREFERENCED_PARAMETER(P)    ((P)=(P))
N#endif
N
N#ifndef REG32
N  #define REG32(addr) (*(volatile unsigned int*)(addr))
N  #define REG16(addr) (*(volatile unsigned short*)(addr))
N  #define REG8(addr)  (*(volatile unsigned char*)(addr))
N#endif
N
N/******************************************************************************\
N* typedef declarations
X
N\******************************************************************************/
N
N#include <tistdtypes.h> /* use typedefs provided with CCS*/
L 1 "E:/TI_workspase/c6701_t/csl/tistdtypes.h" 1
N/*
N *  ======== tistdtypes.h ========
N */
N
N/*
N * These types are also defined by other TI components.  They are bracketed
N * with _TI_STD_TYPES to avoid warnings for duplicate definition.
N *
N * You may get warnings about duplicate type definitions when using this
N * header file with earlier versions of DSP/BIOS and CSL.
N *
N * You can use the '-pds303' compiler option to suppress these warnings.
N */
N#ifndef _TI_STD_TYPES
N#define _TI_STD_TYPES
N
N/*
N * This '#ifndef STD_' is needed to protect from duplicate definitions
N * of Int, Uns, etc. in DSP/BIOS v4.x (e.g. 4.90, 4.80) since these versions
N * of DSP/BIOS did not contain the '#ifndef_TI_STD_TYPES' logic.
N */
N#ifndef STD_
N
N/*
N * Aliases for standard C types
N */
Ntypedef int			Int;
Ntypedef unsigned		Uns;
Ntypedef char			Char;
N
N/* pointer to null-terminated character sequence */
Ntypedef char			*String;
N
Ntypedef void			*Ptr;		/* pointer to arbitrary type */
N
Ntypedef unsigned short		Bool;		/* boolean */
N
N#endif /* STD_ */
N
N/*
N * Uint8, Uint16, Uint32, etc are defined to be "smallest unit of
N * available storage that is large enough to hold unsigned or integer
N * of specified size".
N */
N
N/* Handle the 6x ISA */
N#if defined(_TMS320C6X)
X#if 1L
N    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef unsigned int	Uint32;
N    typedef unsigned short	Uint16;
N    typedef unsigned char	Uint8;
N
N    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
N    typedef int			Int32;
N    typedef short		Int16;
N    typedef char		Int8;
N
N/* Handle the 54x, 55x and 28x ISAs */
N#elif defined(_TMS320C5XX) || defined(__TMS320C55X__) || defined(_TMS320C28X)
S    /* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef unsigned long	Uint32;
S    typedef unsigned short	Uint16;
S    typedef unsigned char	Uint8;
S
S    /* Signed integer definitions (32bit, 16bit, 8bit) follow... */
S    typedef long		Int32;
S    typedef short		Int16;
S    typedef char		Int8;
S
S#else
S    /* Other ISAs not supported */
S    #error <tistdtypes.h> is not supported for this target
N#endif  /* defined(_6x_) */
N
N#endif  /* _TI_STD_TYPES */
L 51 "E:/TI_workspase/c6701_t/csl/csl_stdinc.h" 2
N
N/******************************************************************************\
N* variable declarations
X
N\******************************************************************************/
N
N
N typedef long             Int40;
N typedef unsigned long    Uint40;
N/******************************************************************************\
N* function declarations
X
N\******************************************************************************/
N
N
N#endif /* _CSL_STDINC_H_ */
N/******************************************************************************\
N* End of csl_stdinc.h
X
N\******************************************************************************/
N
L 20 "E:/TI_workspase/c6701_t/csl/csl_emu.h" 2
N#include <csl_emuhal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_emuhal.h" 1
N/**************************************************************************\
N*              Copyright (C) 2002 Texas Instruments Incorporated.
X
N*                             All Rights Reserved
N*--------------------------------------------------------------------------
N* MODULE NAME... EMU
N* FILENAME...... csl_emuhal.h
N* DATE CREATED.. 05/12/2003
N* LAST MODIFIED. 05/20/2003
N* PROJECT....... Chip Support Library
N* COMPONENT..... Hardware Abstraction Layer
N* PREREQUISITES.
N*
N*--------------------------------------------------------------------------
N* DESCRIPTION:
N*        CSL Hardware Abstraction Layer interface for the EMU module
N*
N*--------------------------------------------------------------------------
N* REGISTERS:
N*
N* DBGSTAT   - DBGSTAT {Debug Status Register}
N* MFREG0    - MFREG0 {Miscellaneous Function Register}
N\**************************************************************************/
N
N#ifndef _CSL_EMUHAL_H_
N#define _CSL_EMUHAL_H_
N
N/**************************************************************************\
N* Private Macros and Include files
X
N\**************************************************************************/
N#include <csl_stdinchal.h>
N#include <csl_chiphal.h>
L 1 "E:/TI_workspase/c6701_t/csl/csl_chiphal.h" 1
N/******************************************************************************\
N*           Copyright (C) 2000 Texas Instruments Incorporated.
X
N*                           All Rights Reserved
N*------------------------------------------------------------------------------
N* FILENAME...... csl_chiphal.h
N* DATE CREATED.. 14 Aug 2000
N* LAST MODIFIED. 14 Jan 2004 Adding support for DRI300 versions (6410, 6413)
N*                05 Aug 2003 Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                26 Jun 2003 Added support for 6411
N*                17 Jun 2003 Added support for 6712C
N*                28 May 2003 Added support for 6711C
N*                05 Nov 2001 DM642 , 6411 remove 6400
N*                03 Oct 2001 - CHIP_6713 - MCASP_SUPPORT - IIC_SUPPORT
N*                           - PERCFG register
N*                           - redefinition of CHIP_RSET() / CHIP_RGET()
N*                           - new CHIP_CRSET() / CHIP_CRGET() => modification of csl_irq.h
N*                04 Apr 2004-  Removing external control cregisters EM,ER,IN,OUT and DIER.
N*                12 Jan 2005-  Removing external control cregisters FMCR,FADCR,FAUCR and GFPGFR
N*                06 Apr 2005-  Removing the macros ATLEN,ATLMEN and ADIV according to data manual 
N*                              tms320c6410(13)-sprs247 dated: Feb26 2004 specifications. 
N*				 26 Jul 2005-  Added C++ support.
N*------------------------------------------------------------------------------
N* REGISTERS
N*
N* CSR    - control/status register
N* IFR    - interrupt flag register
N* ISR    - interrupt set register
N* ICR    - interrupt clear register
N* IER    - interrupt enable register
N* ISTP   - interrupt service table pointer register
N* IRP    - interrupt return pointer
N* NRP    - non-maskable interrupt return pointer
N* AMR    - addressing mode reister
N* PERCFG - Device Configuration register  (4)
N* DEVSTAT - Device Status Register (5)
N* JTAGID - JTAG ID register (5)
N*
N* (1) only supported on 67xx
N* (2) only supported on floating point devices
N* (3) only supported on 6411/14/15/16 devices
N* (4) only supported on 6713/DA610/DM642/6412/6711C/6712C devices
N* (5) only supported on DM642/6412/6410/6413 devices
N*
N\******************************************************************************/
N#ifndef _CSL_CHIPHAL_H_
N#define _CSL_CHIPHAL_H_
N
N#include <csl_stdinc.h>
N
N#ifdef __cplusplus
Sextern "C" {
N#endif
N
N
N/******************************************************************************\
N* CHIP identification section
X
N\******************************************************************************/
N#ifdef CHIP_BASELINE
S  #undef CHIP_BASELINE
S  #define CHIP_BASELINE 1
N#else
N  #define CHIP_BASELINE 0
N#endif
N
N#if (CHIP_BASELINE)
X#if (0)
S  #define CHIP_6201 1
N#endif
N
N#ifdef CHIP_6201
S  #undef CHIP_6201
S  #define CHIP_6201 1
N#else
N  #define CHIP_6201 0
N#endif
N
N#ifdef CHIP_6202
S  #undef CHIP_6202
S  #define CHIP_6202 1
N#else
N  #define CHIP_6202 0
N#endif
N
N#ifdef CHIP_6203
S  #undef CHIP_6203
S  #define CHIP_6203 1
N#else
N  #define CHIP_6203 0
N#endif
N
N#ifdef CHIP_6204
S  #undef CHIP_6204
S  #define CHIP_6204 1
N#else
N  #define CHIP_6204 0
N#endif
N
N#ifdef CHIP_6205
S  #undef CHIP_6205
S  #define CHIP_6205 1
N#else
N  #define CHIP_6205 0
N#endif
N
N#ifdef CHIP_6211
S  #undef CHIP_6211
S  #define CHIP_6211 1
N#else
N  #define CHIP_6211 0
N#endif
N
N#ifdef CHIP_6701
N  #undef CHIP_6701
N  #define CHIP_6701 1
N#else
S  #define CHIP_6701 0
N#endif
N
N#ifdef CHIP_6711
S  #undef CHIP_6711
S  #define CHIP_6711 1
N#else
N  #define CHIP_6711 0
N#endif
N
N#ifdef CHIP_6712
S  #undef CHIP_6712
S  #define CHIP_6712 1
N#else
N  #define CHIP_6712 0
N#endif
N
N
N#ifdef CHIP_6713
S  #undef CHIP_6713
S  #define CHIP_6713 1
N#else
N  #define CHIP_6713 0
N#endif
N
N#ifdef CHIP_DA610
S  #undef CHIP_DA610
S  #define CHIP_DA610 1
N#else
N  #define CHIP_DA610 0
N#endif
N
N#ifdef CHIP_DM642
S  #undef CHIP_DM642
S  #define CHIP_DM642 1
N#else
N  #define CHIP_DM642 0
N#endif
N
N#ifdef CHIP_DM641
S  #undef CHIP_DM641
S  #define CHIP_DM641 1
N#else
N  #define CHIP_DM641 0
N#endif
N
N#ifdef CHIP_DM640
S  #undef CHIP_DM640
S  #define CHIP_DM640 1
N#else
N  #define CHIP_DM640 0
N#endif
N
N#ifdef CHIP_6412
S  #undef CHIP_6412
S  #define CHIP_6412 1
N#else
N  #define CHIP_6412 0
N#endif
N
N#ifdef CHIP_6414
S  #undef CHIP_6414
S  #define CHIP_6414 1
N#else
N  #define CHIP_6414 0
N#endif
N
N#ifdef CHIP_6415
S  #undef CHIP_6415
S  #define CHIP_6415 1
N#else
N  #define CHIP_6415 0
N#endif
N
N#ifdef CHIP_6416
S  #undef CHIP_6416
S  #define CHIP_6416 1
N#else
N  #define CHIP_6416 0
N#endif
N
N#ifdef CHIP_6711C
S  #undef CHIP_6711C
S  #define CHIP_6711C 1
N#else
N  #define CHIP_6711C 0
N#endif
N
N#ifdef CHIP_6712C
S  #undef CHIP_6712C
S  #define CHIP_6712C 1
N#else
N  #define CHIP_6712C 0
N#endif
N
N#ifdef CHIP_6411
S  #undef CHIP_6411
S  #define CHIP_6411 1
N#else
N  #define CHIP_6411 0
N#endif
N
N/* next two are DRI300 versions */
N#ifdef CHIP_6410
S  #undef CHIP_6410
S  #define CHIP_6410 1
N#else
N  #define CHIP_6410 0
N#endif
N
N#ifdef CHIP_6413
S  #undef CHIP_6413
S  #define CHIP_6413 1
N#else
N  #define CHIP_6413 0
N#endif
N
N#ifdef CHIP_6418
S  #undef CHIP_6418
S  #define CHIP_6418 1
N#else
N  #define CHIP_6418 0
N#endif
N
N#define CHIP_OROFALL (\
N  CHIP_6201 | \
N  CHIP_6202 | \
N  CHIP_6203 | \
N  CHIP_6204 | \
N  CHIP_6205 | \
N  CHIP_6211 | \
N  CHIP_6701 | \
N  CHIP_6711 | \
N  CHIP_6712 | \
N  CHIP_6713 | \
N  CHIP_DA610 | \
N  CHIP_DM642 | \
N  CHIP_DM641 | \
N  CHIP_DM640 | \
N  CHIP_6412 | \
N  CHIP_6414 | \
N  CHIP_6415 | \
N  CHIP_6416 |  \
N  CHIP_6711C | \
N  CHIP_6712C | \
N  CHIP_6411 |\
N  CHIP_6410 |\
N  CHIP_6413 |\
N  CHIP_6418 \
N)
X#define CHIP_OROFALL (  CHIP_6201 |   CHIP_6202 |   CHIP_6203 |   CHIP_6204 |   CHIP_6205 |   CHIP_6211 |   CHIP_6701 |   CHIP_6711 |   CHIP_6712 |   CHIP_6713 |   CHIP_DA610 |   CHIP_DM642 |   CHIP_DM641 |   CHIP_DM640 |   CHIP_6412 |   CHIP_6414 |   CHIP_6415 |   CHIP_6416 |    CHIP_6711C |   CHIP_6712C |   CHIP_6411 |  CHIP_6410 |  CHIP_6413 |  CHIP_6418 )
N
N#if (CHIP_OROFALL==0)
X#if (( 0 | 0 | 0 | 0 | 0 | 0 | 1 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 0 )==0)
S  #error NO CHIP DEFINED (use -dCHIP_XXXX where XXXX is chip number, i.e. 6201)
N#endif
N
N#define CHIP_NONE 0
N
N#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) ( \
N  ( c0*CHIP_6201)  | \
N  ( c1*CHIP_6202)  | \
N  ( c2*CHIP_6203)  | \
N  ( c3*CHIP_6204)  | \
N  ( c4*CHIP_6205)  | \
N  ( c5*CHIP_6211)  | \
N  ( c6*CHIP_6701)  | \
N  ( c7*CHIP_6711)  | \
N  ( c8*CHIP_6712)  | \
N  ( c9*CHIP_6713)  | \
N  ( c10*CHIP_DA610)| \
N  ( c11*CHIP_DM642)| \
N  ( c12*CHIP_DM641)| \
N  ( c13*CHIP_DM640)| \
N  ( c14*CHIP_6412) | \
N  ( c15*CHIP_6414) | \
N  ( c16*CHIP_6415) | \
N  ( c17*CHIP_6416) | \
N  ( c18*CHIP_6711C) | \
N  ( c19*CHIP_6712C) | \
N  ( c20*CHIP_6411) | \
N  ( c21*CHIP_6410) | \
N  ( c22*CHIP_6413) | \
N  ( c23*CHIP_6418) | \
N  ( c24*CHIP_NONE)   \
N )
X#define CHIP_SUPPORT(c0,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,c24) (   ( c0*CHIP_6201)  |   ( c1*CHIP_6202)  |   ( c2*CHIP_6203)  |   ( c3*CHIP_6204)  |   ( c4*CHIP_6205)  |   ( c5*CHIP_6211)  |   ( c6*CHIP_6701)  |   ( c7*CHIP_6711)  |   ( c8*CHIP_6712)  |   ( c9*CHIP_6713)  |   ( c10*CHIP_DA610)|   ( c11*CHIP_DM642)|   ( c12*CHIP_DM641)|   ( c13*CHIP_DM640)|   ( c14*CHIP_6412) |   ( c15*CHIP_6414) |   ( c16*CHIP_6415) |   ( c17*CHIP_6416) |   ( c18*CHIP_6711C) |   ( c19*CHIP_6712C) |   ( c20*CHIP_6411) |   ( c21*CHIP_6410) |   ( c22*CHIP_6413) |   ( c23*CHIP_6418) |   ( c24*CHIP_NONE)    )
N
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define CACHE_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define DMA_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define EDMA_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define EMIF_SUPPORT      CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define EMIFA_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define EMIFB_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0)
N#define GPIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define HPI_SUPPORT       CHIP_SUPPORT(1,0,0,0,0,1,1,1,0,1,1,1,1,0,1,1,1,1,1,0,1,1,1,1,0)
N#define I2C_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,1,1,1,0)
N#define IRQ_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define MCASP_SUPPORT     CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,1,0)
N#define MCBSP_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PLL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define TIMER_SUPPORT     CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define XBUS_SUPPORT      CHIP_SUPPORT(0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define PCI_SUPPORT       CHIP_SUPPORT(0,0,0,0,1,0,0,0,0,0,0,1,0,0,1,0,1,1,0,0,1,0,0,0,0)
N/*---------------------------------------------------------------------------------------*/
N/*                                     6 6 6 6 6 6 6 6 6 6 D D D D 6 6 6 6 6 6 6 6 6 6 N */
N/*                                     2 2 2 2 2 2 7 7 7 7 A M M M 4 4 4 4 7 7 4 4 4 4 O */
N/*                                     0 0 0 0 0 1 0 1 1 1 6 6 6 6 1 1 1 1 1 1 1 1 1 1 N */
N/*                                     1 2 3 4 5 1 1 1 2 3 1 4 4 4 2 4 5 6 1 2 1 0 3 8 E */
N/*                                                         0 2 1 0         C C           */
N/*---------------------------------------------------------------------------------------*/
N#define VP_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define VIC_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
N#define DAT_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define PWR_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define UTOP_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0)
N#define TCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N#define VCP_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0)
N#define EMAC_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define MDIO_SUPPORT      CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0)
N#define EMU_SUPPORT	  CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0)
N                                                                                       
N#define L2CACHE_SUPPORT   CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define TC_SUPPORT        CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0)
N#define FPU_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C01_SUPPORT       CHIP_SUPPORT(1,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
N#define C11_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,1,0,1,1,1,1,0,0,0,0,0,0,0,1,1,0,0,0,0,0)
N#define C64_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,0)
N#define ATL_SUPPORT       CHIP_SUPPORT(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0)
N
N#define CACHE_L2_SUPPORT  L2CACHE_SUPPORT
N/*----------------------------------------------------------------------*/
N
N
N/******************************************************************************\
N* module level register/field access macros
X
N\******************************************************************************/
N
N  /* ----------------- */
N  /* FIELD MAKE MACROS */
N  /* ----------------- */
N
N  #define CHIP_FMK(REG,FIELD,x)\
N    _PER_FMK(CHIP,##REG,##FIELD,x)
X  #define CHIP_FMK(REG,FIELD,x)    _PER_FMK(CHIP,##REG,##FIELD,x)
N
N  #define CHIP_FMKS(REG,FIELD,SYM)\
N    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
X  #define CHIP_FMKS(REG,FIELD,SYM)    _PER_FMKS(CHIP,##REG,##FIELD,##SYM)
N
N
N  /* -------------------------------- */
N  /* RAW REGISTER/FIELD ACCESS MACROS */
N  /* -------------------------------- */
N
N  #define CHIP_CRGET(REG)\
N    _PER_CRGET(CHIP,##REG)
X  #define CHIP_CRGET(REG)    _PER_CRGET(CHIP,##REG)
N
N  #define CHIP_CRSET(REG,x)\
N    _PER_CRSET(CHIP,##REG,x)
X  #define CHIP_CRSET(REG,x)    _PER_CRSET(CHIP,##REG,x)
N
N  #define CHIP_RGET(REG)\
N   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
X  #define CHIP_RGET(REG)   _PER_RGET(_CHIP_##REG##_ADDR,CHIP,##REG)
N
N  #define CHIP_RSET(REG,x)\
N     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
X  #define CHIP_RSET(REG,x)     _PER_RSET(_CHIP_##REG##_ADDR,CHIP,##REG,x)
N
N
N  #define CHIP_FGET(REG,FIELD)\
N    _CHIP_##REG##_FGET(##FIELD)
X  #define CHIP_FGET(REG,FIELD)    _CHIP_##REG##_FGET(##FIELD)
N
N  #define CHIP_FSET(REG,FIELD,x)\
N    _CHIP_##REG##_FSET(##FIELD,x)
X  #define CHIP_FSET(REG,FIELD,x)    _CHIP_##REG##_FSET(##FIELD,x)
N
N  #define CHIP_FSETS(REG,FIELD,SYM)\
N    _CHIP_##REG##_FSETS(##FIELD,##SYM)
X  #define CHIP_FSETS(REG,FIELD,SYM)    _CHIP_##REG##_FSETS(##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  C S R            |
N* |___________________|
N*
N* CSR - control/status register
N*
N* FIELDS (msb -> lsb)
N* (r)  CPUID
N* (r)  REVID
N* (rw) PWRD
N* (rc) SAT
N* (r)  EN
N* (rw) PCC
N* (rw) DCC
N* (rw) PGIE
N* (rw) GIE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int CSR;
N
N  #define _CHIP_CSR_CPUID_MASK         0xFF000000u
N  #define _CHIP_CSR_CPUID_SHIFT        0x00000018u
N  #define  CHIP_CSR_CPUID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_CPUID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_CPUID_C62X         0x00000000u
N  #define  CHIP_CSR_CPUID_C67X         0x00000002u
N  #define  CHIP_CSR_CPUID_C64X         0x00000004u
N
N  #define _CHIP_CSR_REVID_MASK         0x00FF0000u
N  #define _CHIP_CSR_REVID_SHIFT        0x00000010u
N  #define  CHIP_CSR_REVID_DEFAULT      0x00000000u
N  #define  CHIP_CSR_REVID_OF(x)        _VALUEOF(x)
N  #define  CHIP_CSR_REVID_620120       0x00000001u
N  #define  CHIP_CSR_REVID_620121       0x00000001u
N  #define  CHIP_CSR_REVID_620130       0x00000002u
N  #define  CHIP_CSR_REVID_670100       0x00000201u
N  #define  CHIP_CSR_REVID_670110       0x00000202u
N  #define  CHIP_CSR_REVID_621110       0x00000002u
N  #define  CHIP_CSR_REVID_640010       0x00000801u
N  #define  CHIP_CSR_REVID_6202         0x00000002u
N  #define  CHIP_CSR_REVID_6202B        0x00000003u
N  #define  CHIP_CSR_REVID_6711         0x00000002u
N  #define  CHIP_CSR_REVID_6711C        0x00000003u
N  #define  CHIP_CSR_REVID_6712         0x00000002u
N  #define  CHIP_CSR_REVID_6712C        0x00000003u
N
N  #define _CHIP_CSR_PWRD_MASK          0x0000FC00u
N  #define _CHIP_CSR_PWRD_SHIFT         0x0000000Au
N  #define  CHIP_CSR_PWRD_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PWRD_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PWRD_NONE          0x00000000u
N  #define  CHIP_CSR_PWRD_PD1A          0x00000009u
N  #define  CHIP_CSR_PWRD_PD1B          0x00000011u
N  #define  CHIP_CSR_PWRD_PD2           0x0000001Au
N  #define  CHIP_CSR_PWRD_PD3           0x0000001Cu
N
N  #define _CHIP_CSR_SAT_MASK           0x00000200u
N  #define _CHIP_CSR_SAT_SHIFT          0x00000009u
N  #define  CHIP_CSR_SAT_DEFAULT        0x00000000u
N  #define  CHIP_CSR_SAT_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_SAT_0              0x00000000u
N  #define  CHIP_CSR_SAT_1              0x00000001u
N
N  #define _CHIP_CSR_EN_MASK            0x00000100u
N  #define _CHIP_CSR_EN_SHIFT           0x00000008u
N  #define  CHIP_CSR_EN_DEFAULT         0x00000000u
N  #define  CHIP_CSR_EN_OF(x)           _VALUEOF(x)
N  #define  CHIP_CSR_EN_BIG             0x00000000u
N  #define  CHIP_CSR_EN_LITTLE          0x00000001u
N
N  #define _CHIP_CSR_PCC_MASK           0x000000E0u
N  #define _CHIP_CSR_PCC_SHIFT          0x00000005u
N  #define  CHIP_CSR_PCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_PCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_PCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_PCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_PCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_PCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_DCC_MASK           0x0000001Cu
N  #define _CHIP_CSR_DCC_SHIFT          0x00000002u
N  #define  CHIP_CSR_DCC_DEFAULT        0x00000000u
N  #define  CHIP_CSR_DCC_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_DCC_MAPPED         0x00000000u
N  #define  CHIP_CSR_DCC_ENABLE         0x00000002u
N  #define  CHIP_CSR_DCC_FREEZE         0x00000003u
N  #define  CHIP_CSR_DCC_BYPASS         0x00000004u
N
N  #define _CHIP_CSR_PGIE_MASK          0x00000002u
N  #define _CHIP_CSR_PGIE_SHIFT         0x00000001u
N  #define  CHIP_CSR_PGIE_DEFAULT       0x00000000u
N  #define  CHIP_CSR_PGIE_OF(x)         _VALUEOF(x)
N  #define  CHIP_CSR_PGIE_0             0x00000000u
N  #define  CHIP_CSR_PGIE_1             0x00000001u
N
N  #define _CHIP_CSR_GIE_MASK           0x00000001u
N  #define _CHIP_CSR_GIE_SHIFT          0x00000000u
N  #define  CHIP_CSR_GIE_DEFAULT        0x00000000u
N  #define  CHIP_CSR_GIE_OF(x)          _VALUEOF(x)
N  #define  CHIP_CSR_GIE_0              0x00000000u
N  #define  CHIP_CSR_GIE_1              0x00000001u
N
N  #define  CHIP_CSR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_CSR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,CSR,CPUID) \
N    |_PER_FDEFAULT(CHIP,CSR,REVID) \
N    |_PER_FDEFAULT(CHIP,CSR,PWRD) \
N    |_PER_FDEFAULT(CHIP,CSR,SAT) \
N    |_PER_FDEFAULT(CHIP,CSR,EN) \
N    |_PER_FDEFAULT(CHIP,CSR,PCC) \
N    |_PER_FDEFAULT(CHIP,CSR,DCC) \
N    |_PER_FDEFAULT(CHIP,CSR,PGIE) \
N    |_PER_FDEFAULT(CHIP,CSR,GIE) \
N  )
X  #define CHIP_CSR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,CSR,CPUID)     |_PER_FDEFAULT(CHIP,CSR,REVID)     |_PER_FDEFAULT(CHIP,CSR,PWRD)     |_PER_FDEFAULT(CHIP,CSR,SAT)     |_PER_FDEFAULT(CHIP,CSR,EN)     |_PER_FDEFAULT(CHIP,CSR,PCC)     |_PER_FDEFAULT(CHIP,CSR,DCC)     |_PER_FDEFAULT(CHIP,CSR,PGIE)     |_PER_FDEFAULT(CHIP,CSR,GIE)   )
N
N  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)( \
N     _PER_FMK(CHIP,CSR,PWRD,pwrd) \
N    |_PER_FMK(CHIP,CSR,PCC,pcc) \
N    |_PER_FMK(CHIP,CSR,DCC,dcc) \
N    |_PER_FMK(CHIP,CSR,PGIE,pgie) \
N    |_PER_FMK(CHIP,CSR,GIE,gie) \
N  )
X  #define CHIP_CSR_RMK(pwrd,pcc,dcc,pgie,gie) (Uint32)(      _PER_FMK(CHIP,CSR,PWRD,pwrd)     |_PER_FMK(CHIP,CSR,PCC,pcc)     |_PER_FMK(CHIP,CSR,DCC,dcc)     |_PER_FMK(CHIP,CSR,PGIE,pgie)     |_PER_FMK(CHIP,CSR,GIE,gie)   )
N
N  #define _CHIP_CSR_FGET(FIELD)\
N    _PER_CFGET(CHIP,CSR,##FIELD)
X  #define _CHIP_CSR_FGET(FIELD)    _PER_CFGET(CHIP,CSR,##FIELD)
N
N  #define _CHIP_CSR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,CSR,##FIELD,field)
X  #define _CHIP_CSR_FSET(FIELD,field)    _PER_CFSET(CHIP,CSR,##FIELD,field)
N
N  #define _CHIP_CSR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
X  #define _CHIP_CSR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,CSR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I F R            |
N* |___________________|
N*
N* IFR - interruppt flag register
N*
N* FIELDS (msb -> lsb)
N* (rw) IF
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IFR;
N
N  #define _CHIP_IFR_IF_MASK          0x0000FFFFu
N  #define _CHIP_IFR_IF_SHIFT         0x00000000u
N  #define  CHIP_IFR_IF_DEFAULT       0x00000000u
N  #define  CHIP_IFR_IF_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IFR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IFR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IFR,IF)\
N  )
X  #define CHIP_IFR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IFR,IF)  )
N
N  #define CHIP_IFR_RMK(if) (Uint32)( \
N     _PER_FMK(CHIP,IFR,IF,if)\
N  )
X  #define CHIP_IFR_RMK(if) (Uint32)(      _PER_FMK(CHIP,IFR,IF,if)  )
N
N  #define _CHIP_IFR_FGET(FIELD)\
N    _PER_CFGET(CHIP,IFR,##FIELD)
X  #define _CHIP_IFR_FGET(FIELD)    _PER_CFGET(CHIP,IFR,##FIELD)
N
N  #define _CHIP_IFR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IFR,##FIELD,field)
X  #define _CHIP_IFR_FSET(FIELD,field)    _PER_CFSET(CHIP,IFR,##FIELD,field)
N
N  #define _CHIP_IFR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
X  #define _CHIP_IFR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IFR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S R            |
N* |___________________|
N*
N* ISR - interruppt set register
N*
N* FIELDS (msb -> lsb)
N* (w) IS
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISR;
N
N  #define _CHIP_ISR_IS_MASK          0x0000FFFFu
N  #define _CHIP_ISR_IS_SHIFT         0x00000000u
N  #define  CHIP_ISR_IS_DEFAULT       0x00000000u
N  #define  CHIP_ISR_IS_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ISR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ISR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISR,IS)\
N  )
X  #define CHIP_ISR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISR,IS)  )
N
N  #define CHIP_ISR_RMK(is) (Uint32)( \
N     _PER_FMK(CHIP,ISR,IS,is)\
N  )
X  #define CHIP_ISR_RMK(is) (Uint32)(      _PER_FMK(CHIP,ISR,IS,is)  )
N
N  #define _CHIP_ISR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISR,##FIELD)
X  #define _CHIP_ISR_FGET(FIELD)    _PER_CFGET(CHIP,ISR,##FIELD)
N
N  #define _CHIP_ISR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISR,##FIELD,field)
X  #define _CHIP_ISR_FSET(FIELD,field)    _PER_CFSET(CHIP,ISR,##FIELD,field)
N
N  #define _CHIP_ISR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
X  #define _CHIP_ISR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I C R            |
N* |___________________|
N*
N* ICR - interruppt clear register
N*
N* FIELDS (msb -> lsb)
N* (w) IC
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ICR;
N
N  #define _CHIP_ICR_IC_MASK          0x0000FFFFu
N  #define _CHIP_ICR_IC_SHIFT         0x00000000u
N  #define  CHIP_ICR_IC_DEFAULT       0x00000000u
N  #define  CHIP_ICR_IC_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_ICR_OF(x)            _VALUEOF(x)
N
N  #define CHIP_ICR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ICR,IC)\
N  )
X  #define CHIP_ICR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ICR,IC)  )
N
N  #define CHIP_ICR_RMK(ic) (Uint32)( \
N     _PER_FMK(CHIP,ICR,IC,ic)\
N  )
X  #define CHIP_ICR_RMK(ic) (Uint32)(      _PER_FMK(CHIP,ICR,IC,ic)  )
N
N  #define _CHIP_ICR_FGET(FIELD)\
N    _PER_CFGET(CHIP,ICR,##FIELD)
X  #define _CHIP_ICR_FGET(FIELD)    _PER_CFGET(CHIP,ICR,##FIELD)
N
N  #define _CHIP_ICR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ICR,##FIELD,field)
X  #define _CHIP_ICR_FSET(FIELD,field)    _PER_CFSET(CHIP,ICR,##FIELD,field)
N
N  #define _CHIP_ICR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
X  #define _CHIP_ICR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ICR,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I E R            |
N* |___________________|
N*
N* IER - interruppt enable register
N*
N* FIELDS (msb -> lsb)
N* (rw) IE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IER;
N
N  #define _CHIP_IER_IE_MASK          0x0000FFFFu
N  #define _CHIP_IER_IE_SHIFT         0x00000000u
N  #define  CHIP_IER_IE_DEFAULT       0x00000000u
N  #define  CHIP_IER_IE_OF(x)         _VALUEOF(x)
N
N  #define  CHIP_IER_OF(x)            _VALUEOF(x)
N
N  #define CHIP_IER_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IER,IE)\
N  )
X  #define CHIP_IER_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IER,IE)  )
N
N  #define CHIP_IER_RMK(ie) (Uint32)( \
N     _PER_FMK(CHIP,IER,IE,ie)\
N  )
X  #define CHIP_IER_RMK(ie) (Uint32)(      _PER_FMK(CHIP,IER,IE,ie)  )
N
N  #define _CHIP_IER_FGET(FIELD)\
N    _PER_CFGET(CHIP,IER,##FIELD)
X  #define _CHIP_IER_FGET(FIELD)    _PER_CFGET(CHIP,IER,##FIELD)
N
N  #define _CHIP_IER_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IER,##FIELD,field)
X  #define _CHIP_IER_FSET(FIELD,field)    _PER_CFSET(CHIP,IER,##FIELD,field)
N
N  #define _CHIP_IER_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
X  #define _CHIP_IER_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IER,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I S T P          |
N* |___________________|
N*
N* ISTP - interrupt service table pointer
N*
N* FIELDS (msb -> lsb)
N* (r)   HPEINT
N* (rw)  ISTB
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int ISTP;
N
N  #define _CHIP_ISTP_ISTB_MASK         0xFFFFFC00u
N  #define _CHIP_ISTP_ISTB_SHIFT        0x0000000Au
N  #define  CHIP_ISTP_ISTB_DEFAULT      0x00000000u
N  #define  CHIP_ISTP_ISTB_OF(x)        _VALUEOF(x)
N
N  #define _CHIP_ISTP_HPEINT_MASK       0x000003E0u
N  #define _CHIP_ISTP_HPEINT_SHIFT      0x00000005u
N  #define  CHIP_ISTP_HPEINT_DEFAULT    0x00000000u
N  #define  CHIP_ISTP_HPEINT_OF(x)      _VALUEOF(x)
N
N  #define  CHIP_ISTP_OF(x)             _VALUEOF(x)
N
N  #define CHIP_ISTP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,ISTP,ISTB)\
N    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)\
N  )
X  #define CHIP_ISTP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,ISTP,ISTB)    |_PER_FDEFAULT(CHIP,ISTP,HPEINT)  )
N
N  #define CHIP_ISTP_RMK(istb) (Uint32)( \
N     _PER_FMK(CHIP,ISTP,ISTB,istb)\
N  )
X  #define CHIP_ISTP_RMK(istb) (Uint32)(      _PER_FMK(CHIP,ISTP,ISTB,istb)  )
N
N  #define _CHIP_ISTP_FGET(FIELD)\
N    _PER_CFGET(CHIP,ISTP,##FIELD)
X  #define _CHIP_ISTP_FGET(FIELD)    _PER_CFGET(CHIP,ISTP,##FIELD)
N
N  #define _CHIP_ISTP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,ISTP,##FIELD,field)
X  #define _CHIP_ISTP_FSET(FIELD,field)    _PER_CFSET(CHIP,ISTP,##FIELD,field)
N
N  #define _CHIP_ISTP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
X  #define _CHIP_ISTP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,ISTP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  I R P            |
N* |___________________|
N*
N* IRP - interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) IRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int IRP;
N
N  #define _CHIP_IRP_IRP_MASK           0xFFFFFFFFu
N  #define _CHIP_IRP_IRP_SHIFT          0x00000000u
N  #define  CHIP_IRP_IRP_DEFAULT        0x00000000u
N  #define  CHIP_IRP_IRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_IRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_IRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,IRP,IRP)\
N  )
X  #define CHIP_IRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,IRP,IRP)  )
N
N  #define CHIP_IRP_RMK(irp) (Uint32)( \
N     _PER_FMK(CHIP,IRP,IRP,irp)\
N  )
X  #define CHIP_IRP_RMK(irp) (Uint32)(      _PER_FMK(CHIP,IRP,IRP,irp)  )
N
N  #define _CHIP_IRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,IRP,##FIELD)
X  #define _CHIP_IRP_FGET(FIELD)    _PER_CFGET(CHIP,IRP,##FIELD)
N
N  #define _CHIP_IRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,IRP,##FIELD,field)
X  #define _CHIP_IRP_FSET(FIELD,field)    _PER_CFSET(CHIP,IRP,##FIELD,field)
N
N  #define _CHIP_IRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
X  #define _CHIP_IRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,IRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  N R P            |
N* |___________________|
N*
N* NRP - non-maskable interrupt return pointer
N*
N* FIELDS (msb -> lsb)
N* (rw) NRP
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int NRP;
N
N  #define _CHIP_NRP_NRP_MASK           0xFFFFFFFFu
N  #define _CHIP_NRP_NRP_SHIFT          0x00000000u
N  #define  CHIP_NRP_NRP_DEFAULT        0x00000000u
N  #define  CHIP_NRP_NRP_OF(x)          _VALUEOF(x)
N
N  #define  CHIP_NRP_OF(x)              _VALUEOF(x)
N
N  #define CHIP_NRP_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,NRP,NRP)\
N  )
X  #define CHIP_NRP_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,NRP,NRP)  )
N
N  #define CHIP_NRP_RMK(nrp) (Uint32)( \
N     _PER_FMK(CHIP,NRP,NRP,nrp)\
N  )
X  #define CHIP_NRP_RMK(nrp) (Uint32)(      _PER_FMK(CHIP,NRP,NRP,nrp)  )
N
N  #define _CHIP_NRP_FGET(FIELD)\
N    _PER_CFGET(CHIP,NRP,##FIELD)
X  #define _CHIP_NRP_FGET(FIELD)    _PER_CFGET(CHIP,NRP,##FIELD)
N
N  #define _CHIP_NRP_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,NRP,##FIELD,field)
X  #define _CHIP_NRP_FSET(FIELD,field)    _PER_CFSET(CHIP,NRP,##FIELD,field)
N
N  #define _CHIP_NRP_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
X  #define _CHIP_NRP_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,NRP,##FIELD,##SYM)
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  A M R            |
N* |___________________|
N*
N* AMR - addressing mode register
N*
N* FIELDS (msb -> lsb)
N* (rw) BK1
N* (rw) BK0
N* (rw) B7MODE
N* (rw) B6MODE
N* (rw) B5MODE
N* (rw) B4MODE
N* (rw) A7MODE
N* (rw) A6MODE
N* (rw) A5MODE
N* (rw) A4MODE
N*
N\******************************************************************************/
N  extern far cregister volatile unsigned int AMR;
N
N  #define _CHIP_AMR_BK1_MASK           0x02E00000u
N  #define _CHIP_AMR_BK1_SHIFT          0x00000015u
N  #define  CHIP_AMR_BK1_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK1_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK1_2              0x00000000u
N  #define  CHIP_AMR_BK1_4              0x00000001u
N  #define  CHIP_AMR_BK1_8              0x00000002u
N  #define  CHIP_AMR_BK1_16             0x00000003u
N  #define  CHIP_AMR_BK1_32             0x00000004u
N  #define  CHIP_AMR_BK1_64             0x00000005u
N  #define  CHIP_AMR_BK1_128            0x00000006u
N  #define  CHIP_AMR_BK1_256            0x00000007u
N  #define  CHIP_AMR_BK1_512            0x00000008u
N  #define  CHIP_AMR_BK1_1K             0x00000009u
N  #define  CHIP_AMR_BK1_2K             0x0000000Au
N  #define  CHIP_AMR_BK1_4K             0x0000000Bu
N  #define  CHIP_AMR_BK1_8K             0x0000000Cu
N  #define  CHIP_AMR_BK1_16K            0x0000000Du
N  #define  CHIP_AMR_BK1_32K            0x0000000Eu
N  #define  CHIP_AMR_BK1_64K            0x0000000Fu
N  #define  CHIP_AMR_BK1_128K           0x00000010u
N  #define  CHIP_AMR_BK1_256K           0x00000011u
N  #define  CHIP_AMR_BK1_512K           0x00000012u
N  #define  CHIP_AMR_BK1_1M             0x00000013u
N  #define  CHIP_AMR_BK1_2M             0x00000014u
N  #define  CHIP_AMR_BK1_4M             0x00000015u
N  #define  CHIP_AMR_BK1_8M             0x00000016u
N  #define  CHIP_AMR_BK1_16M            0x00000017u
N  #define  CHIP_AMR_BK1_32M            0x00000018u
N  #define  CHIP_AMR_BK1_64M            0x00000019u
N  #define  CHIP_AMR_BK1_128M           0x0000001Au
N  #define  CHIP_AMR_BK1_256M           0x0000001Bu
N  #define  CHIP_AMR_BK1_512M           0x0000001Cu
N  #define  CHIP_AMR_BK1_1G             0x0000001Du
N  #define  CHIP_AMR_BK1_2G             0x0000001Eu
N  #define  CHIP_AMR_BK1_4G             0x0000001Fu
N
N  #define _CHIP_AMR_BK0_MASK           0x001F0000u
N  #define _CHIP_AMR_BK0_SHIFT          0x00000010u
N  #define  CHIP_AMR_BK0_DEFAULT        0x00000000u
N  #define  CHIP_AMR_BK0_OF(x)          _VALUEOF(x)
N  #define  CHIP_AMR_BK0_2              0x00000000u
N  #define  CHIP_AMR_BK0_4              0x00000001u
N  #define  CHIP_AMR_BK0_8              0x00000002u
N  #define  CHIP_AMR_BK0_16             0x00000003u
N  #define  CHIP_AMR_BK0_32             0x00000004u
N  #define  CHIP_AMR_BK0_64             0x00000005u
N  #define  CHIP_AMR_BK0_128            0x00000006u
N  #define  CHIP_AMR_BK0_256            0x00000007u
N  #define  CHIP_AMR_BK0_512            0x00000008u
N  #define  CHIP_AMR_BK0_1K             0x00000009u
N  #define  CHIP_AMR_BK0_2K             0x0000000Au
N  #define  CHIP_AMR_BK0_4K             0x0000000Bu
N  #define  CHIP_AMR_BK0_8K             0x0000000Cu
N  #define  CHIP_AMR_BK0_16K            0x0000000Du
N  #define  CHIP_AMR_BK0_32K            0x0000000Eu
N  #define  CHIP_AMR_BK0_64K            0x0000000Fu
N  #define  CHIP_AMR_BK0_128K           0x00000010u
N  #define  CHIP_AMR_BK0_256K           0x00000011u
N  #define  CHIP_AMR_BK0_512K           0x00000012u
N  #define  CHIP_AMR_BK0_1M             0x00000013u
N  #define  CHIP_AMR_BK0_2M             0x00000014u
N  #define  CHIP_AMR_BK0_4M             0x00000015u
N  #define  CHIP_AMR_BK0_8M             0x00000016u
N  #define  CHIP_AMR_BK0_16M            0x00000017u
N  #define  CHIP_AMR_BK0_32M            0x00000018u
N  #define  CHIP_AMR_BK0_64M            0x00000019u
N  #define  CHIP_AMR_BK0_128M           0x0000001Au
N  #define  CHIP_AMR_BK0_256M           0x0000001Bu
N  #define  CHIP_AMR_BK0_512M           0x0000001Cu
N  #define  CHIP_AMR_BK0_1G             0x0000001Du
N  #define  CHIP_AMR_BK0_2G             0x0000001Eu
N  #define  CHIP_AMR_BK0_4G             0x0000001Fu
N
N
N  #define _CHIP_AMR_B7MODE_MASK        0x0000C000u
N  #define _CHIP_AMR_B7MODE_SHIFT       0x0000000Eu
N  #define  CHIP_AMR_B7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B6MODE_MASK        0x00003000u
N  #define _CHIP_AMR_B6MODE_SHIFT       0x0000000Cu
N  #define  CHIP_AMR_B6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B5MODE_MASK        0x00000C00u
N  #define _CHIP_AMR_B5MODE_SHIFT       0x0000000Au
N  #define  CHIP_AMR_B5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_B4MODE_MASK        0x00000300u
N  #define _CHIP_AMR_B4MODE_SHIFT       0x00000008u
N  #define  CHIP_AMR_B4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_B4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_B4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_B4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_B4MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A7MODE_MASK        0x000000C0u
N  #define _CHIP_AMR_A7MODE_SHIFT       0x00000006u
N  #define  CHIP_AMR_A7MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A7MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A7MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A7MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A7MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A6MODE_MASK        0x00000030u
N  #define _CHIP_AMR_A6MODE_SHIFT       0x00000004u
N  #define  CHIP_AMR_A6MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A6MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A6MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A6MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A6MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A5MODE_MASK        0x0000000Cu
N  #define _CHIP_AMR_A5MODE_SHIFT       0x00000002u
N  #define  CHIP_AMR_A5MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A5MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A5MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A5MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A5MODE_CIRCULAR1   0x00000002u
N
N  #define _CHIP_AMR_A4MODE_MASK        0x00000003u
N  #define _CHIP_AMR_A4MODE_SHIFT       0x00000000u
N  #define  CHIP_AMR_A4MODE_DEFAULT     0x00000000u
N  #define  CHIP_AMR_A4MODE_OF(x)       _VALUEOF(x)
N  #define  CHIP_AMR_A4MODE_LINEAR      0x00000000u
N  #define  CHIP_AMR_A4MODE_CIRCULAR0   0x00000001u
N  #define  CHIP_AMR_A4MODE_CIRCULAR1   0x00000002u
N
N  #define  CHIP_AMR_OF(x)              _VALUEOF(x)
N
N  #define CHIP_AMR_DEFAULT (Uint32)( \
N     _PER_FDEFAULT(CHIP,AMR,BK1)\
N    |_PER_FDEFAULT(CHIP,AMR,BK0)\
N    |_PER_FDEFAULT(CHIP,AMR,B7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,B4MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A7MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A6MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A5MODE)\
N    |_PER_FDEFAULT(CHIP,AMR,A4MODE)\
N  )
X  #define CHIP_AMR_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,AMR,BK1)    |_PER_FDEFAULT(CHIP,AMR,BK0)    |_PER_FDEFAULT(CHIP,AMR,B7MODE)    |_PER_FDEFAULT(CHIP,AMR,B6MODE)    |_PER_FDEFAULT(CHIP,AMR,B5MODE)    |_PER_FDEFAULT(CHIP,AMR,B4MODE)    |_PER_FDEFAULT(CHIP,AMR,A7MODE)    |_PER_FDEFAULT(CHIP,AMR,A6MODE)    |_PER_FDEFAULT(CHIP,AMR,A5MODE)    |_PER_FDEFAULT(CHIP,AMR,A4MODE)  )
N
N  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,\
N    a6mode,a5mode,a4mode) (Uint32)( \
N     _PER_FMK(CHIP,AMR,BK1,bk1)\
N    |_PER_FMK(CHIP,AMR,BK0,bk0)\
N    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)\
N    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)\
N    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)\
N    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)\
N    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)\
N    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)\
N    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)\
N    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)\
N  )
X  #define CHIP_AMR_RMK(bk1,bk0,b7mode,b6mode,b5mode,b4mode,a7,ode,    a6mode,a5mode,a4mode) (Uint32)(      _PER_FMK(CHIP,AMR,BK1,bk1)    |_PER_FMK(CHIP,AMR,BK0,bk0)    |_PER_FMK(CHIP,AMR,B7MODE,b7mode)    |_PER_FMK(CHIP,AMR,B6MODE,b6mode)    |_PER_FMK(CHIP,AMR,B5MODE,b5mode)    |_PER_FMK(CHIP,AMR,B4MODE,b4mode)    |_PER_FMK(CHIP,AMR,A7MODE,a7mode)    |_PER_FMK(CHIP,AMR,A6MODE,a6mode)    |_PER_FMK(CHIP,AMR,A5MODE,a5mode)    |_PER_FMK(CHIP,AMR,A4MODE,a4mode)  )
N
N  #define _CHIP_AMR_FGET(FIELD)\
N    _PER_CFGET(CHIP,AMR,##FIELD)
X  #define _CHIP_AMR_FGET(FIELD)    _PER_CFGET(CHIP,AMR,##FIELD)
N
N  #define _CHIP_AMR_FSET(FIELD,field)\
N    _PER_CFSET(CHIP,AMR,##FIELD,field)
X  #define _CHIP_AMR_FSET(FIELD,field)    _PER_CFSET(CHIP,AMR,##FIELD,field)
N
N  #define _CHIP_AMR_FSETS(FIELD,SYM)\
N    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
X  #define _CHIP_AMR_FSETS(FIELD,SYM)    _PER_CFSETS(CHIP,AMR,##FIELD,##SYM)
N
N
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V C F G      |
N* |___________________|
N*
N* PERCFG - Device Configuration register (1)
N*
N* FIELDS (msb -> lsb)  CHIP_6713/CHIP_DA610
N* (rw) EKSRC
N* (rw) TOUT1SEL
N* (rw) TOUT0SEL
N* (rw) MCBSP0DIS
N* (rw) MCBSP1DIS
N* (rw) GPIO1EN (only for CHIP_DA610)
N*
N* FIELDS (msb -> lsb)  CHIP_DM642
N* (rw) VP2EN
N* (rw) VP1EN
N* (rw) VP0EN
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N* (rw) MCASP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6412
N* (rw) I2C0EN
N* (rw) MCBSP1EN
N* (rw) MCBSP0EN
N*
N* FIELDS (msb -> lsb)  CHIP_6711C/CHIP_6712C
N* (rw) EKSRC
N*
N* FIELDS (msb -> lsb)  CHIP_6410/CHIP_6413/CHIP_6418
N* (rw) AFCMUX
N* (rw) MCASP1EN
N* (rw) I2C1EN
N* (rw) I2C0EN
N* (r) MCBSP1EN
N* (r) MCBSP0EN
N* (rw) MCASP0EN
N*
N\******************************************************************************/
N
N#if (CHIP_DA610)
X#if (0)
S
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_GPIO1EN_MASK        0x00010000u
S  #define _CHIP_DEVCFG_GPIO1EN_SHIFT       0x0000000Fu
S  #define  CHIP_DEVCFG_GPIO1EN_DEFAULT     0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_GPIO1EN_0           0x00000000u
S  #define  CHIP_DEVCFG_GPIO1EN_1           0x00000001u
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK       0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT      0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0          0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1          0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK         0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT        0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT      0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0            0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1            0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,GPIO1EN)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,\
S                          gpio1en ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S    |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis,                          gpio1en ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis)     |_PER_FMK(CHIP,DEVCFG,GPIO1EN,gpio1en) )
S#elif (CHIP_6713)
X#elif (0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET             0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT1SEL_MASK       0x00000008u
S  #define _CHIP_DEVCFG_TOUT1SEL_SHIFT      0x00000003u
S  #define  CHIP_DEVCFG_TOUT1SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT1SEL_TOUT1PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT1SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_TOUT0SEL_MASK       0x00000004u
S  #define _CHIP_DEVCFG_TOUT0SEL_SHIFT      0x00000002u
S  #define  CHIP_DEVCFG_TOUT0SEL_DEFAULT    0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVCFG_TOUT0SEL_TOUT0PIN   0x00000000u
S  #define  CHIP_DEVCFG_TOUT0SEL_MCASPPIN   0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP0DIS_MASK      0x00000002u
S  #define _CHIP_DEVCFG_MCBSP0DIS_SHIFT     0x00000001u
S  #define  CHIP_DEVCFG_MCBSP0DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP0DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP0DIS_1         0x00000001u
S
S  #define _CHIP_DEVCFG_MCBSP1DIS_MASK      0x00000001u
S  #define _CHIP_DEVCFG_MCBSP1DIS_SHIFT     0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_DEFAULT   0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_OF(x)     _VALUEOF(x)
S  #define  CHIP_DEVCFG_MCBSP1DIS_0         0x00000000u
S  #define  CHIP_DEVCFG_MCBSP1DIS_1         0x00000001u
S
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS) \
S    |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT1SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,TOUT0SEL)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP0DIS)     |_PER_FDEFAULT(CHIP,DEVCFG,MCBSP1DIS)  )
S
S  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis\
S                          ) (Uint32)( \
S      _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel) \
S    |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis) \
S    |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) \
S)
X  #define CHIP_DEVCFG_RMK(eksrc,tout1sel,tout0sel,mcbsp0dis,mcbsp1dis                          ) (Uint32)(       _PER_FMK(CHIP,DEVCFG,EKSRC,eksrc)     |_PER_FMK(CHIP,DEVCFG,TOUT1SEL,tout1sel)     |_PER_FMK(CHIP,DEVCFG,TOUT0SEL,tout0sel)     |_PER_FMK(CHIP,DEVCFG,MCBSP0DIS,mcbsp0dis)     |_PER_FMK(CHIP,DEVCFG,MCBSP1DIS,mcbsp1dis) )
S
N#endif
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412)
X#if (0 || 0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S
S#if (CHIP_DM642)
S  #define _CHIP_PERCFG_VP2EN_MASK            0x00000040u
S  #define _CHIP_PERCFG_VP2EN_SHIFT           0x00000006u
S  #define  CHIP_PERCFG_VP2EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP2EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP2EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641)                          
S  #define _CHIP_PERCFG_VP1EN_MASK            0x00000020u
S  #define _CHIP_PERCFG_VP1EN_SHIFT           0x00000005u
S  #define  CHIP_PERCFG_VP1EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP1EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP1EN_ENABLE          0x00000001u
S#endif
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)                          
S  #define _CHIP_PERCFG_VP0EN_MASK            0x00000010u
S  #define _CHIP_PERCFG_VP0EN_SHIFT           0x00000004u
S  #define  CHIP_PERCFG_VP0EN_DEFAULT         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_VP0EN_DISABLE         0x00000000u
S  #define  CHIP_PERCFG_VP0EN_ENABLE          0x00000001u
S#endif
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S#endif
S
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S#if (CHIP_DM642)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP2EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP2EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP2EN,vp2en) \
S    |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp2en,vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP2EN,vp2en)     |_PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM641)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP1EN,vp1en) \
S    |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp1en,vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP1EN,vp1en)     |_PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_DM640)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,VP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,VP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)( \
S     _PER_FMK(CHIP,PERCFG,VP0EN,vp0en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )
X #define CHIP_PERCFG_RMK(vp0en,i2c0en,mcbsp1en,mcbsp0en,mcasp0en) (Uint32)(      _PER_FMK(CHIP,PERCFG,VP0EN,vp0en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )
S#endif
S
S#if (CHIP_6412)
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S   )
X  #define CHIP_PERCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)    )
S
S
S #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)( \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en) \
S    |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en) \
S  )
X #define CHIP_PERCFG_RMK(i2c0en,mcbsp1en,mcbsp0en) (Uint32)(     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCBSP1EN,mcbsp1en)     |_PER_FMK(CHIP,PERCFG,MCBSP0EN,mcbsp0en)   )
S#endif
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_PERCFG_ADDR                0x01B3F000u
S  #define   _CHIP_PERCFG_OFFSET              0
S  
S  #define _CHIP_PERCFG_AFCMUX_MASK           0x00000600u
S  #define _CHIP_PERCFG_AFCMUX_SHIFT          0x00000009u
S  #define  CHIP_PERCFG_AFCMUX_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_OF(x)           _VALUEOF(x)
S  #define  CHIP_PERCFG_AFCMUX_PIN0           0x00000000u
S  #define  CHIP_PERCFG_AFCMUX_PIN1           0x00000001u
S  #define  CHIP_PERCFG_AFCMUX_PIN2           0x00000002u
S  #define  CHIP_PERCFG_AFCMUX_PIN3           0x00000003u
S 
S  #define _CHIP_PERCFG_MCASP1EN_MASK         0x00000100u
S  #define _CHIP_PERCFG_MCASP1EN_SHIFT        0x00000008u
S  #define  CHIP_PERCFG_MCASP1EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP1EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_I2C1EN_MASK           0x00000080u
S  #define _CHIP_PERCFG_I2C1EN_SHIFT          0x00000007u
S  #define  CHIP_PERCFG_I2C1EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C1EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C1EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_I2C0EN_MASK           0x00000008u
S  #define _CHIP_PERCFG_I2C0EN_SHIFT          0x00000003u
S  #define  CHIP_PERCFG_I2C0EN_DEFAULT        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_OF(x)          _VALUEOF(x)
S  #define  CHIP_PERCFG_I2C0EN_DISABLE        0x00000000u
S  #define  CHIP_PERCFG_I2C0EN_ENABLE         0x00000001u
S
S  #define _CHIP_PERCFG_MCBSP1EN_MASK         0x00000004u
S  #define _CHIP_PERCFG_MCBSP1EN_SHIFT        0x00000002u
S  #define  CHIP_PERCFG_MCBSP1EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP1EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP1EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP1EN_ENABLE       0x00000001u
S 
S  #define _CHIP_PERCFG_MCBSP0EN_MASK         0x00000002u
S  #define _CHIP_PERCFG_MCBSP0EN_SHIFT        0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_DEFAULT      0x00000001u
S  #define  CHIP_PERCFG_MCBSP0EN_OF(x)        _VALUEOF(x)
S  #define  CHIP_PERCFG_MCBSP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCBSP0EN_ENABLE       0x00000001u
S
S  #define _CHIP_PERCFG_MCASP0EN_MASK         0x00000001u
S  #define _CHIP_PERCFG_MCASP0EN_SHIFT        0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_DEFAULT      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_OF(x)         _VALUEOF(x)
S  #define  CHIP_PERCFG_MCASP0EN_DISABLE      0x00000000u
S  #define  CHIP_PERCFG_MCASP0EN_ENABLE       0x00000001u
S
S  #define  CHIP_PERCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_PERCFG_DEFAULT (Uint32)( \
S    _PER_FDEFAULT(CHIP,PERCFG,AFCMUX) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN) \
S    |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN) \
S   )  
X  #define CHIP_PERCFG_DEFAULT (Uint32)(     _PER_FDEFAULT(CHIP,PERCFG,AFCMUX)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C1EN)     |_PER_FDEFAULT(CHIP,PERCFG,I2C0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP1EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCBSP0EN)     |_PER_FDEFAULT(CHIP,PERCFG,MCASP0EN)    )  
S  
S
S #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)( \
S    _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux) \
S    |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en) \
S    |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en) \
S    |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en) \
S  )  
X #define CHIP_PERCFG_RMK(afcmux,mcasp1en,i2c1en,i2c0en,mcasp0en) (Uint32)(     _PER_FMK(CHIP,PERCFG,AFCMUX,afcmux)     |_PER_FMK(CHIP,PERCFG,MCASP1EN,mcasp1en)     |_PER_FMK(CHIP,PERCFG,I2C1EN,i2c1en)     |_PER_FMK(CHIP,PERCFG,I2C0EN,i2c0en)     |_PER_FMK(CHIP,PERCFG,MCASP0EN,mcasp0en)   )  
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N#if (CHIP_6711C || CHIP_6712C)
X#if (0 || 0)
S  #define   _CHIP_DEVCFG_ADDR              0x019C0200u
S  #define   _CHIP_DEVCFG_OFFSET            0
S
S  #define _CHIP_DEVCFG_EKSRC_MASK          0x00000010u
S  #define _CHIP_DEVCFG_EKSRC_SHIFT         0x00000004u
S  #define  CHIP_DEVCFG_EKSRC_DEFAULT       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVCFG_EKSRC_SYSCLK3       0x00000000u
S  #define  CHIP_DEVCFG_EKSRC_ECLKIN        0x00000001u
S
S  #define  CHIP_DEVCFG_OF(x)              _VALUEOF(x)
S
S  #define CHIP_DEVCFG_DEFAULT (Uint32)( \
S     _PER_FDEFAULT(CHIP,DEVCFG,EKSRC) \
S )
X  #define CHIP_DEVCFG_DEFAULT (Uint32)(      _PER_FDEFAULT(CHIP,DEVCFG,EKSRC)  )
S
S  #define CHIP_PERCFG_RMK(eksrc) (Uint32)( \
S      _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) \
S)
X  #define CHIP_PERCFG_RMK(eksrc) (Uint32)(       _PER_FMK(CHIP,PERCFG,EKSRC,eksrc) )
S
N#endif /* CHIP_6711C || CHIP_6712C */
N
N#if (CHIP_6711C || CHIP_6712C || CHIP_DA610 || CHIP_6713) 
X#if (0 || 0 || 0 || 0) 
S  #define _CHIP_DEVCFG_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
X  #define _CHIP_DEVCFG_FGET(FIELD)    _PER_FGET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD)
S
S  #define _CHIP_DEVCFG_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
X  #define _CHIP_DEVCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,field)
S
S  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
X  #define _CHIP_DEVCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_DEVCFG_ADDR,CHIP,DEVCFG,##FIELD,##SYM)
S   
N#else
N  
N  #define _CHIP_PERCFG_FGET(FIELD)\
N    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
X  #define _CHIP_PERCFG_FGET(FIELD)    _PER_FGET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD)
N
N  #define _CHIP_PERCFG_FSET(FIELD,field)\
N    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
X  #define _CHIP_PERCFG_FSET(FIELD,field)    _PER_FSET(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,field)
N
N  #define _CHIP_PERCFG_FSETS(FIELD,SYM)\
N    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
X  #define _CHIP_PERCFG_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PERCFG_ADDR,CHIP,PERCFG,##FIELD,##SYM)
N#endif
N
N/*----------------------------------------------------------------------------*/
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  D E V S T A T    |
N* |___________________|
N*
N* DEVSTAT - Device Status Register (1)
N*
N* FIELDS (msb -> lsb)
N* DM642
N* (r) MACEN
N* (r) HPIWIDTH
N* (r) PCIEEAI
N* (r) PCIEN
N* (r) CLKMODE
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* DRI300
N* (r) PLLM
N* (r) OSCEXTRES
N* (r) CLKINSEL
N* (r) CLKMODE3
N* (r) HPIWIDTH
N* (r) HPIENZ
N* (r) CLKMODE2
N* (r) CLKMODE1
N* (r) CLKMODE0
N* (r) LENDIAN
N* (r) BOOTMODE
N* (r) AECLKINSEL
N*
N* 
N\******************************************************************************/
N#if (CHIP_DM642 | CHIP_DM641 | CHIP_DM640 | CHIP_6412)
X#if (0 | 0 | 0 | 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET              0
S
S  #define _CHIP_DEVSTAT_MACEN_MASK            0x00000800u
S  #define _CHIP_DEVSTAT_MACEN_SHIFT           0x0000000Bu
S  #define  CHIP_DEVSTAT_MACEN_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_MACEN_DISABLE         0x00000000u
S  #define  CHIP_DEVSTAT_MACEN_ENABLE          0x00000001u
S
S #if !(CHIP_DM640)
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK            0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT           0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16              0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32              0x00000001u
S #endif
S
S #if !(CHIP_DM641 | CHIP_DM640)
S  #define _CHIP_DEVSTAT_PCIEEAI_MASK            0x00000200u
S  #define _CHIP_DEVSTAT_PCIEEAI_SHIFT           0x00000009u
S  #define  CHIP_DEVSTAT_PCIEEAI_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEEAI_NONE            0x00000000u
S  #define  CHIP_DEVSTAT_PCIEEAI_INIT            0x00000001u
S
S  #define _CHIP_DEVSTAT_PCIEN_MASK           0x00000100u
S  #define _CHIP_DEVSTAT_PCIEN_SHIFT          0x00000008u
S  #define  CHIP_DEVSTAT_PCIEN_DEFAULT        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PCIEN_DISABLE        0x00000000u
S  #define  CHIP_DEVSTAT_PCIEN_ENABLE         0x00000001u
S #endif
S
S  #define _CHIP_DEVSTAT_CLKMODE_MASK         0x00000060u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT        0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_X1           0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_X6           0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_X12          0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_X20          0x00000003u
S
S  #define _CHIP_DEVSTAT_LENDIAN_MASK         0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT        0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT      0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG          0x00000000u
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE       0x00000001u
S
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK         0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT        0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE         0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPIPCI       0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA        0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK         0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT        0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4      0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6      0x00000002u
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_DM642 | CHIP_6412  */
N
N#if (CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0)
S
S  #define   _CHIP_DEVSTAT_ADDR                 0x01B3F004u
S  #define   _CHIP_DEVSTAT_OFFSET               0
S
S  #define _CHIP_DEVSTAT_PLLM_MASK              0x00F10000u
S  #define _CHIP_DEVSTAT_PLLM_SHIFT             0x00000013u
S  #define  CHIP_DEVSTAT_PLLM_DEFAULT           0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_OF(x)             _VALUEOF(x)
S  #define  CHIP_DEVSTAT_PLLM_BYPASS            0x00000000u
S  #define  CHIP_DEVSTAT_PLLM_5                 0x00000001u
S  #define  CHIP_DEVSTAT_PLLM_6                 0x00000002u
S  #define  CHIP_DEVSTAT_PLLM_7                 0x00000003u
S  #define  CHIP_DEVSTAT_PLLM_8                 0x00000004u
S  #define  CHIP_DEVSTAT_PLLM_9                 0x00000005u
S  #define  CHIP_DEVSTAT_PLLM_10                0x00000006u
S  #define  CHIP_DEVSTAT_PLLM_11                0x00000007u
S  #define  CHIP_DEVSTAT_PLLM_12                0x00000008u
S  #define  CHIP_DEVSTAT_PLLM_16                0x00000009u
S  #define  CHIP_DEVSTAT_PLLM_18                0x0000000Au
S  #define  CHIP_DEVSTAT_PLLM_19                0x0000000Bu
S  #define  CHIP_DEVSTAT_PLLM_20                0x0000000Cu
S  #define  CHIP_DEVSTAT_PLLM_21                0x0000000Du
S  #define  CHIP_DEVSTAT_PLLM_22                0x0000000Eu
S  #define  CHIP_DEVSTAT_PLLM_24                0x0000000Fu
S 
S  #define _CHIP_DEVSTAT_OSCEXTRES_MASK         0x00020000u
S  #define _CHIP_DEVSTAT_OSCEXTRES_SHIFT        0x00000011u
S  #define  CHIP_DEVSTAT_OSCEXTRES_DEFAUL       0x00000001u
S  #define  CHIP_DEVSTAT_OSCEXTRES_OF(x)        _VALUEOF(x)
S  #define  CHIP_DEVSTAT_OSCEXTRES_DISABL       0x00000000u
S  #define  CHIP_DEVSTAT_OSCEXTRES_ENABLE       0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKINSEL_MASK          0x00010000u
S  #define _CHIP_DEVSTAT_CLKINSEL_SHIFT         0x00000010u
S  #define  CHIP_DEVSTAT_CLKINSEL_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKINSEL_DISABLE       0x00000000u
S  #define  CHIP_DEVSTAT_CLKINSEL_ENABLE        0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIWIDTH_MASK          0x00000400u
S  #define _CHIP_DEVSTAT_HPIWIDTH_SHIFT         0x0000000Au
S  #define  CHIP_DEVSTAT_HPIWIDTH_DEFAUL        0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIWIDTH_16            0x00000000u
S  #define  CHIP_DEVSTAT_HPIWIDTH_32            0x00000001u
S 
S  #define _CHIP_DEVSTAT_HPIENZ_MASK            0x00000100u
S  #define _CHIP_DEVSTAT_HPIENZ_SHIFT           0x00000008u
S  #define  CHIP_DEVSTAT_HPIENZ_DEFAULT         0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_OF(x)           _VALUEOF(x)
S  #define  CHIP_DEVSTAT_HPIENZ_ENABLE          0x00000000u
S  #define  CHIP_DEVSTAT_HPIENZ_DISABLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_CLKMODE_MASK          0x000010E0u
S  #define _CHIP_DEVSTAT_CLKMODE_SHIFT         0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_DEFAULT       0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_OF(x)         _VALUEOF(x)
S  #define  CHIP_DEVSTAT_CLKMODE_0             0x00000000u
S  #define  CHIP_DEVSTAT_CLKMODE_1             0x00000001u
S  #define  CHIP_DEVSTAT_CLKMODE_2             0x00000002u
S  #define  CHIP_DEVSTAT_CLKMODE_3             0x00000003u
S  #define  CHIP_DEVSTAT_CLKMODE_4             0x00000004u
S  #define  CHIP_DEVSTAT_CLKMODE_5             0x00000005u
S  #define  CHIP_DEVSTAT_CLKMODE_6             0x00000006u
S  #define  CHIP_DEVSTAT_CLKMODE_7             0x00000007u
S  #define  CHIP_DEVSTAT_CLKMODE_8             0x00000080u
S  #define  CHIP_DEVSTAT_CLKMODE_9             0x00000081u
S  #define  CHIP_DEVSTAT_CLKMODE_10            0x00000082u
S  #define  CHIP_DEVSTAT_CLKMODE_11            0x00000083u
S  #define  CHIP_DEVSTAT_CLKMODE_12            0x00000084u
S  #define  CHIP_DEVSTAT_CLKMODE_13            0x00000085u
S  #define  CHIP_DEVSTAT_CLKMODE_14            0x00000086u
S  #define  CHIP_DEVSTAT_CLKMODE_15            0x00000087u
S 
S  #define _CHIP_DEVSTAT_LENDIAN_MASK           0x00000010u
S  #define _CHIP_DEVSTAT_LENDIAN_SHIFT          0x00000004u
S  #define  CHIP_DEVSTAT_LENDIAN_DEFAULT        0x00000001u
S  #define  CHIP_DEVSTAT_LENDIAN_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_LENDIAN_BIG            0x00000000u 
S  #define  CHIP_DEVSTAT_LENDIAN_LITTLE         0x00000001u
S 
S  #define _CHIP_DEVSTAT_BOOTMODE_MASK          0x0000000Cu
S  #define _CHIP_DEVSTAT_BOOTMODE_SHIFT         0x00000002u
S  #define  CHIP_DEVSTAT_BOOTMODE_DEFAULT       0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_OF(x)          _VALUEOF(x)
S  #define  CHIP_DEVSTAT_BOOTMODE_NONE          0x00000000u
S  #define  CHIP_DEVSTAT_BOOTMODE_HPI           0x00000001u
S  #define  CHIP_DEVSTAT_BOOTMODE_EMIFA         0x00000003u
S
S  #define _CHIP_DEVSTAT_AECLKINSEL_MASK        0x00000003u
S  #define _CHIP_DEVSTAT_AECLKINSEL_SHIFT       0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_DEFAULT     0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_OF(x)       _VALUEOF(x)
S  #define  CHIP_DEVSTAT_AECLKINSEL_ECLKIN      0x00000000u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT4     0x00000001u
S  #define  CHIP_DEVSTAT_AECLKINSEL_CLKOUT6     0x00000002u
S
S  #define  CHIP_DEVSTAT_OF(x)              _VALUEOF(x)
S
S  /* Read only Register */
S
S  #define _CHIP_DEVSTAT_FGET(FIELD)\
S    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
X  #define _CHIP_DEVSTAT_FGET(FIELD)    _PER_FGET(_CHIP_DEVSTAT_ADDR,CHIP,DEVSTAT,##FIELD)
S
S
N#endif /* CHIP_6410 || CHIP_6413 || CHIP_6418 */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  J T A G I D      |
N* |___________________|
N*
N* JTAGID - JTAG ID register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) VARIANT
N* (r) PART
N* (r) MANNUFACTURE
N* (r) LSB
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 )
X#if (0 || 0 || 0 || 0 )
S
S  #define   _CHIP_JTAGID_ADDR                0x01B3F008u
S  #define   _CHIP_JTAGID_OFFSET              0
S
S  #define _CHIP_JTAGID_VARIANT_MASK          0xF0000000u
S  #define _CHIP_JTAGID_VARIANT_SHIFT         0x0000001Cu
S  #define  CHIP_JTAGID_VARIANT_DEFAULT       0x00000000u
S  #define  CHIP_JTAGID_VARIANT_OF(x)         _VALUEOF(x)
S
S  #define _CHIP_JTAGID_PART_MASK             0x0FFFF000u
S  #define _CHIP_JTAGID_PART_SHIFT            0x0000000Cu
S  #define  CHIP_JTAGID_PART_DEFAULT          0x00000079u
S  #define  CHIP_JTAGID_PART_OF(x)            _VALUEOF(x)
S
S  #define _CHIP_JTAGID_MANUFACTURE_MASK      0x00000FFEu
S  #define _CHIP_JTAGID_MANUFACTURE_SHIFT     0x00000001u
S  #define  CHIP_JTAGID_MANUFACTURE_DEFAULT   0x00000017u
S  #define  CHIP_JTAGID_MANUFACTURE_OF(x)     _VALUEOF(x)
S
S  #define _CHIP_JTAGID_LSB_MASK              0x00000001u
S  #define _CHIP_JTAGID_LSB_SHIFT             0x00000000u
S  #define  CHIP_JTAGID_LSB_DEFAULT           0x00000001u
S  #define  CHIP_JTAGID_LSB_OF(x)             _VALUEOF(x)
S
S  #define  CHIP_JTAGID_OF(x)              _VALUEOF(x)
S
S  #define _CHIP_JTAGID_FGET(FIELD)\
S    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
X  #define _CHIP_JTAGID_FGET(FIELD)    _PER_FGET(_CHIP_JTAGID_ADDR,CHIP,JTAGID,##FIELD)
S
N#endif /* CHIP_DM642 || CHIP_6412  */
N
N/******************************************************************************\
N* _____________________
X
N* |                   |
N* |  P C F G L O C K  |
N* |___________________|
N*
N* PCFGLOCK - Peripheral Configuration Lock register (1)
N*
N* FIELDS (msb -> lsb)
N* (r) LOCKSTAT
N* (w) LOCK
N*
N* (1) Only for DM642
N*
N\******************************************************************************/
N
N#if (CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418)
X#if (0 || 0 || 0 || 0 || 0 || 0 || 0)
S
S  #define   _CHIP_PCFGLOCK_ADDR                 0x01B3F018u
S  #define   _CHIP_PCFGLOCK_OFFSET               0
S
S  #define _CHIP_PCFGLOCK_LOCKSTAT_MASK          0x00000001u
S  #define _CHIP_PCFGLOCK_LOCKSTAT_SHIFT         0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_DEFAULT       0x00000001u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_OF(x)         _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCKSTAT_UNLOCK        0x00000000u
S  #define  CHIP_PCFGLOCK_LOCKSTAT_LOCK          0x00000001u
S
S  #define _CHIP_PCFGLOCK_LOCK_MASK              0xFFFFFFFFu
S  #define _CHIP_PCFGLOCK_LOCK_SHIFT             0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_DEFAULT           0x00000000u
S  #define  CHIP_PCFGLOCK_LOCK_OF(x)             _VALUEOF(x)
S  #define  CHIP_PCFGLOCK_LOCK_UNLOCK            0x10C0010Cu
S  #define  CHIP_PCFGLOCK_LOCK_DISABLE           0x10C0010Cu
S
S  #define  CHIP_PCFGLOCK_OF(x)                  _VALUEOF(x)
S
S  #define _CHIP_PCFGLOCK_FGET(FIELD)\
S    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
X  #define _CHIP_PCFGLOCK_FGET(FIELD)    _PER_FGET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD)
S
S  #define _CHIP_PCFGLOCK_FSET(FIELD,field)\
S    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
X  #define _CHIP_PCFGLOCK_FSET(FIELD,field)    _PER_FSET(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,field)
S
S  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)\
S    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
X  #define _CHIP_PCFGLOCK_FSETS(FIELD,SYM)    _PER_FSETS(_CHIP_PCFGLOCK_ADDR,CHIP,PCFGLOCK,##FIELD,##SYM)
S
S
N#endif /* CHIP_DM642 || CHIP_DM641 || CHIP_DM640 || CHIP_6412 || CHIP_6410 || CHIP_6413 || CHIP_6418*/
N
N#ifdef __cplusplus
S}
N#endif
N
N/*----------------------------------------------------------------------------*/
N#endif /* _CSL_CHIPHAL_H_ */
N/******************************************************************************\
N* End of csl_chiphal.h
X
N\******************************************************************************/
N
L 32 "E:/TI_workspase/c6701_t/csl/csl_emuhal.h" 2
N
N#if (EMU_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S
S
S/**************************************************************************\
S* Module level register/field access macros
X
S\**************************************************************************/
S
S  /* ----------------- */
S  /* FIELD MAKE MACROS */
S  /* ----------------- */
S    #define EMU_FMK(REG, FIELD, x)                                        \
S    _PER_FMK(EMU, ##REG, ##FIELD, x)
X    #define EMU_FMK(REG, FIELD, x)                                            _PER_FMK(EMU, ##REG, ##FIELD, x)
S    #define EMU_FMKS(REG, FIELD, SYM)                                     \
S    _PER_FMKS(EMU, ##REG, ##FIELD, ##SYM)
X    #define EMU_FMKS(REG, FIELD, SYM)                                         _PER_FMKS(EMU, ##REG, ##FIELD, ##SYM)
S
S  /* -------------------------------- */
S  /* RAW REGISTER/FIELD ACCESS MACROS */
S  /* -------------------------------- */
S  #define EMU_ADDR(REG)             _EMU_##REG##_ADDR
S    #define EMU_RGET(REG)                                                 \
S    _PER_RGET(_EMU_##REG##_ADDR, EMU, ##REG)
X    #define EMU_RGET(REG)                                                     _PER_RGET(_EMU_##REG##_ADDR, EMU, ##REG)
S    #define EMU_RSET(REG, x)                                              \
S    _PER_RSET(_EMU_##REG##_ADDR, EMU, ##REG, x)
X    #define EMU_RSET(REG, x)                                                  _PER_RSET(_EMU_##REG##_ADDR, EMU, ##REG, x)
S  #define EMU_FGET(REG, FLD)        _EMU_##REG##_FGET(##FLD)
S  #define EMU_FSET(REG, FLD, x)     _EMU_##REG##_FSET(##FLD, x)
S    #define EMU_FSETS(REG, FLD, SYM)                                      \
S    _EMU_##REG##_FSETS(##FLD, ##SYM)
X    #define EMU_FSETS(REG, FLD, SYM)                                          _EMU_##REG##_FSETS(##FLD, ##SYM)
S
S  /* ------------------------------------------ */
S  /* ADDRESS BASED REGISTER/FIELD ACCESS MACROS */
S  /* ------------------------------------------ */
S  #define EMU_RGETA(addr, REG)      _PER_RGET(addr, EMU, ##REG)
S  #define EMU_RSETA(addr, REG, x)   _PER_RSET(addr, EMU, ##REG,x)
S    #define EMU_FGETA(addr, REG, FLD)                                     \
S    _PER_FGET(addr, EMU, ##REG,##FLD)
X    #define EMU_FGETA(addr, REG, FLD)                                         _PER_FGET(addr, EMU, ##REG,##FLD)
S    #define EMU_FSETA(addr, REG, FLD, x)                                  \
S    _PER_FSET(addr, EMU, ##REG, ##FLD, x)
X    #define EMU_FSETA(addr, REG, FLD, x)                                      _PER_FSET(addr, EMU, ##REG, ##FLD, x)
S    #define EMU_FSETSA(addr, REG, FLD, SYM)                               \
S    _PER_FSETS(addr, EMU, ##REG, ##FLD, ##SYM)
X    #define EMU_FSETSA(addr, REG, FLD, SYM)                                   _PER_FSETS(addr, EMU, ##REG, ##FLD, ##SYM)
S
S  /* ----------------------------------------- */
S  /* HANDLE BASED REGISTER/FIELD ACCESS MACROS */
S  /* ----------------------------------------- */
S    #define EMU_ADDRH(h, REG)                                             \
S    ((void *)(&(((EMU_PrivateObj *)h)->baseAddr[_EMU_##REG##_OFFSET])))
X    #define EMU_ADDRH(h, REG)                                                 ((void *)(&(((EMU_PrivateObj *)h)->baseAddr[_EMU_##REG##_OFFSET])))
S    #define EMU_RGETH(h, REG)                                             \
S    EMU_RGETA(EMU_ADDRH(h, ##REG), ##REG)
X    #define EMU_RGETH(h, REG)                                                 EMU_RGETA(EMU_ADDRH(h, ##REG), ##REG)
S    #define EMU_RSETH(h, REG, x)                                          \
S    EMU_RSETA(EMU_ADDRH(h, ##REG), ##REG, x)
X    #define EMU_RSETH(h, REG, x)                                              EMU_RSETA(EMU_ADDRH(h, ##REG), ##REG, x)
S    #define EMU_FGETH(h, REG, FIELD)                                      \
S    EMU_FGETA(EMU_ADDRH(h, ##REG), ##REG, ##FIELD)
X    #define EMU_FGETH(h, REG, FIELD)                                          EMU_FGETA(EMU_ADDRH(h, ##REG), ##REG, ##FIELD)
S    #define EMU_FSETH(h, REG, FIELD,x)                                    \
S    EMU_FSETA(EMU_ADDRH(h, ##REG), ##REG, ##FIELD, x)
X    #define EMU_FSETH(h, REG, FIELD,x)                                        EMU_FSETA(EMU_ADDRH(h, ##REG), ##REG, ##FIELD, x)
S    #define EMU_FSETSH(h, REG, FIELD, SYM)                                \
S    EMU_FSETSA(EMU_ADDRH(h, ##REG), ##REG, ##FIELD, ##SYM)
X    #define EMU_FSETSH(h, REG, FIELD, SYM)                                    EMU_FSETSA(EMU_ADDRH(h, ##REG), ##REG, ##FIELD, ##SYM)
S
S
S/**************************************************************************\
S*
X
S* _____________________
S* |                   |
S* |   D B G S T A T   |
S* |___________________|
S*
S* DBGSTAT - DBGSTAT {Debug Status Register}
S*
S* FIELDS (msb -> lsb)
S*     (r)     DBGMST          Read MFREG0:DBGM state
S*     (r)     EALLOWST        Read MFREG0:EALLOW state
S\**************************************************************************/
S
S  #define _EMU_DBGSTAT_ADDR         (0x01BC0000)
S  #define _EMU_DBGSTAT              (*(Uint32 *)_EMU_DBGSTAT_ADDR)
S
S  #define _EMU_DBGSTAT_DBGMST_MASK  (0x00020000u)
S  #define _EMU_DBGSTAT_DBGMST_SHIFT (0x00000011u)
S
S  #define EMU_DBGSTAT_DBGMST_OF(x)  _VALUEOF(x)
S
S    #define _EMU_DBGSTAT_EALLOWST_MASK                                    \
S    (0x00010000u)
X    #define _EMU_DBGSTAT_EALLOWST_MASK                                        (0x00010000u)
S    #define _EMU_DBGSTAT_EALLOWST_SHIFT                                   \
S    (0x00000010u)
X    #define _EMU_DBGSTAT_EALLOWST_SHIFT                                       (0x00000010u)
S    #define EMU_DBGSTAT_EALLOWST_OF(x)                                    \
S    _VALUEOF(x)
X    #define EMU_DBGSTAT_EALLOWST_OF(x)                                        _VALUEOF(x)
S
S  #define EMU_DBGSTAT_OF(x)         _VALUEOF(x)
S
S
S    #define _EMU_DBGSTAT_FGET(FLD)                                        \
S    _PER_FGET(_EMU_DBGSTAT_ADDR, EMU, DBGSTAT, ##FLD)
X    #define _EMU_DBGSTAT_FGET(FLD)                                            _PER_FGET(_EMU_DBGSTAT_ADDR, EMU, DBGSTAT, ##FLD)
S    #define _EMU_DBGSTAT_FSET(FLD, f)                                     \
S    _PER_FSET(_EMU_DBGSTAT_ADDR, EMU, DBGSTAT, ##FLD,f)
X    #define _EMU_DBGSTAT_FSET(FLD, f)                                         _PER_FSET(_EMU_DBGSTAT_ADDR, EMU, DBGSTAT, ##FLD,f)
S    #define _EMU_DBGSTAT_FSETS(FLD, SYM)                                  \
S    _PER_FSETS(_EMU_DBGSTAT_ADDR, EMU, DBGSTAT, ##FLD, ##SYM)
X    #define _EMU_DBGSTAT_FSETS(FLD, SYM)                                      _PER_FSETS(_EMU_DBGSTAT_ADDR, EMU, DBGSTAT, ##FLD, ##SYM)
S
S
S/**************************************************************************\
S*
X
S* _____________________
S* |                   |
S* |    M F R E G 0    |
S* |___________________|
S*
S* MFREG0 - MFREG0 {Miscellaneous Function Register}
S*
S* FIELDS (msb -> lsb)
S*     (w)     DBGMLD          Load qualifier for the DBGM bit
S*     (w)     DBGM            Set a mask to inhibit debug access
S*     (w)     ABRTILD         Load qualifier for the ABORTI bit
S*     (w)     ABRTI           set the bit to ABORT a lost ISR
S*     (w)     EALLOWLD        Load qualifier for the EALLOW bit
S*     (w)     EALLOW          Set the bit to allow Emulation access
S\**************************************************************************/
S
S  #define _EMU_MFREG0_ADDR          (0x01BC0014)
S  #define _EMU_MFREG0               (*(Uint32 *)_EMU_MFREG0_ADDR)
S
S  #define _EMU_MFREG0_DBGMLD_MASK   (0x08000000u)
S  #define _EMU_MFREG0_DBGMLD_SHIFT  (0x0000001Bu)
S  #define EMU_MFREG0_DBGMLD_OF(x)   _VALUEOF(x)
S
S  #define _EMU_MFREG0_DBGM_MASK     (0x04000000u)
S  #define _EMU_MFREG0_DBGM_SHIFT    (0x0000001Au)
S  #define EMU_MFREG0_DBGM_OF(x)     _VALUEOF(x)
S
S  #define _EMU_MFREG0_ABRTILD_MASK  (0x00040000u)
S  #define _EMU_MFREG0_ABRTILD_SHIFT (0x00000012u)
S  #define EMU_MFREG0_ABRTILD_OF(x)  _VALUEOF(x)
S
S  #define _EMU_MFREG0_ABRTI_MASK    (0x00020000u)
S  #define _EMU_MFREG0_ABRTI_SHIFT   (0x00000011u)
S  #define EMU_MFREG0_ABRTI_OF(x)    _VALUEOF(x)
S
S  #define _EMU_MFREG0_EALLOWLD_MASK (0x00004000u)
S    #define _EMU_MFREG0_EALLOWLD_SHIFT                                    \
S    (0x0000000Eu)
X    #define _EMU_MFREG0_EALLOWLD_SHIFT                                        (0x0000000Eu)
S  #define EMU_MFREG0_EALLOWLD_OF(x) _VALUEOF(x)
S
S  #define _EMU_MFREG0_EALLOW_MASK   (0x00002000u)
S  #define _EMU_MFREG0_EALLOW_SHIFT  (0x0000000Du)
S  #define EMU_MFREG0_EALLOW_OF(x)   _VALUEOF(x)
S
S  #define EMU_MFREG0_OF(x)          _VALUEOF(x)
S
S  #define EMU_MFREG0_RMK(dbgmld, dbgm, abrtild, abrti, eallowld, eallow) ((Uint32)    (\
S                  _PER_FMK(EMU, MFREG0, DBGMLD, dbgmld)                   \
S                |_PER_FMK(EMU, MFREG0, DBGM, dbgm)                        \
S                |_PER_FMK(EMU, MFREG0, ABRTILD, abrtild)                  \
S                |_PER_FMK(EMU, MFREG0, ABRTI, abrti)                      \
S                |_PER_FMK(EMU, MFREG0, EALLOWLD, eallowld)                \
S                |_PER_FMK(EMU, MFREG0, EALLOW, eallow)                    \
S        )                                                                 \
S  )
X  #define EMU_MFREG0_RMK(dbgmld, dbgm, abrtild, abrti, eallowld, eallow) ((Uint32)    (                  _PER_FMK(EMU, MFREG0, DBGMLD, dbgmld)                                   |_PER_FMK(EMU, MFREG0, DBGM, dbgm)                                        |_PER_FMK(EMU, MFREG0, ABRTILD, abrtild)                                  |_PER_FMK(EMU, MFREG0, ABRTI, abrti)                                      |_PER_FMK(EMU, MFREG0, EALLOWLD, eallowld)                                |_PER_FMK(EMU, MFREG0, EALLOW, eallow)                            )                                                                   )
S
S    #define _EMU_MFREG0_FGET(FLD)                                         \
S    _PER_FGET(_EMU_MFREG0_ADDR, EMU, MFREG0, ##FLD)
X    #define _EMU_MFREG0_FGET(FLD)                                             _PER_FGET(_EMU_MFREG0_ADDR, EMU, MFREG0, ##FLD)
S    #define _EMU_MFREG0_FSET(FLD, f)                                      \
S    _PER_FSET(_EMU_MFREG0_ADDR, EMU, MFREG0, ##FLD,f)
X    #define _EMU_MFREG0_FSET(FLD, f)                                          _PER_FSET(_EMU_MFREG0_ADDR, EMU, MFREG0, ##FLD,f)
S    #define _EMU_MFREG0_FSETS(FLD, SYM)                                   \
S    _PER_FSETS(_EMU_MFREG0_ADDR, EMU, MFREG0, ##FLD, ##SYM)
X    #define _EMU_MFREG0_FSETS(FLD, SYM)                                       _PER_FSETS(_EMU_MFREG0_ADDR, EMU, MFREG0, ##FLD, ##SYM)
S
S
S
N#endif /* (EMU_SUPPORT) */
N#endif /* _CSL_EMUHAL_H_ */
N
N/**************************************************************************\
N* End of csl_emuhal.h
X
N\**************************************************************************/
L 21 "E:/TI_workspase/c6701_t/csl/csl_emu.h" 2
N
N#if (EMU_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S
S/**************************************************************************\
S* EMU scope and inline control macros
X
S\**************************************************************************/
S
S#ifdef __cplusplus
S#   define CSLAPI extern "C" far
S#else
S#   define CSLAPI extern far
S#endif
S
S#undef USEDEFS
S#undef IDECL
S#undef IDEF
S
S#ifdef      _EMU_MOD_
S#   define  IDECL CSLAPI
S#   define  USEDEFS
S#   define  IDEF
S#else
S#   ifdef   _INLINE
S#       define  IDECL           static inline
S#       define  USEDEFS
S#       define  IDEF            static inline
S#   else
S#       define  IDECL           CSLAPI
S#   endif
S#endif
S
S/**************************************************************************\
S* EMU global macro declarations
X
S\**************************************************************************/
S
S#define EMU_DEVICE_CNT            (1)        /* The number of EMU devices */
S
S#define EMU_SUCCESS               (1)
S
S#define EMU_FAILURE               (0)
S
S/**************************************************************************\
S* EMU global typedef declarations
X
S\**************************************************************************/
S/**************************************************************************\
S* EMU global function declarations
X
S\**************************************************************************/
S
SCSLAPI Uint32  EMU_setDBGM(
S    void
S);
S
S
SCSLAPI Uint32  EMU_clrDBGM(
S    void
S);
S
S
SCSLAPI Uint32  EMU_getDBGM(
S    void
S);
S
S
SCSLAPI void  EMU_setABORTI(
S    void
S);
S
S
SCSLAPI void  EMU_clrABORTI(
S    void
S);
S
S
SCSLAPI Uint32  EMU_setEALLOW(
S    void
S);
S
S
SCSLAPI Uint32  EMU_clrEALLOW(
S    void
S);
S
S
SCSLAPI Uint32  EMU_getEALLOW(
S    void
S);
S
S
SCSLAPI Uint32  EMU_getDBGSTAT(
S    void
S);
S
S/**************************************************************************\
S* EMU inline function declarations
X
S\**************************************************************************/
S/**************************************************************************\
S* EMU inline function declarations
X
S\**************************************************************************/
S
S#ifdef USEDEFS
S
S#endif /*USEDEFS */
S
S
S
N#endif      /* EMU_SUPPORT  */
N
N#endif      /* _CSL_EMUHAL_H  */
N
N/**************************************************************************\
N*                               End of csl_emu.h
X
N\**************************************************************************/
L 20 "../csl/csl_emu.c" 2
N
N#if (EMU_SUPPORT)
X#if (( ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*1) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0)| ( 0*0) | ( 0*0) | ( 0*0) | ( 1*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) | ( 0*0) ))
S
S/**************************************************************************\
S*                          L O C A L   S E C T I O N
X
S\**************************************************************************/
S
S/**************************************************************************\
S* EMU static macro declarations
X
S\**************************************************************************/
S
S/**************************************************************************\
S* EMU static typedef declarations
X
S\**************************************************************************/
S
S/**************************************************************************\
S* EMU static function declarations
X
S\**************************************************************************/
S
S/**************************************************************************\
S*                         G L O B A L   S E C T I O N
X
S\**************************************************************************/
S
S/**************************************************************************\
S* EMU global function definitions
X
S\**************************************************************************/
S
SCSLAPI Uint32  EMU_setDBGM(
S    void
S)
S{
S	EMU_RSET(MFREG0, EMU_MFREG0_RMK(1, 1, 0, 0, 0, 0));
S
S	if(EMU_FGET(DBGSTAT, DBGMST) == 1)
S	{
S		return EMU_SUCCESS;
S	}
S	else
S	{
S		return EMU_FAILURE;
S	}
S
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI Uint32  EMU_clrDBGM(
S    void
S)
S{
S
S	EMU_RSET(MFREG0, EMU_MFREG0_RMK(1, 0, 0, 0, 0, 0));
S
S	if(EMU_FGET(DBGSTAT, DBGMST) == 0)
S	{
S		return EMU_SUCCESS;
S	}
S	else
S	{
S		return EMU_FAILURE;
S	}
S
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI Uint32  EMU_getDBGM(
S    void
S)
S{
S	return(EMU_FGET(DBGSTAT, DBGMST));
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI void  EMU_setABORTI(
S    void
S)
S{
S	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 1, 1, 0, 0));
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI void  EMU_clrABORTI(
S    void
S)
S{
S	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 1, 0, 0, 0));
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI Uint32  EMU_setEALLOW(
S    void
S)
S{
S	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 0, 0, 1, 1));
S
S	if(EMU_FGET(DBGSTAT, EALLOWST) == 1)
S	{
S		return EMU_SUCCESS;
S	}
S	else
S	{
S		return EMU_FAILURE;
S	}
S
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI Uint32  EMU_clrEALLOW(
S    void
S)
S{
S	EMU_RSET(MFREG0, EMU_MFREG0_RMK(0, 0, 0, 0, 1, 0));
S
S	if(EMU_FGET(DBGSTAT, EALLOWST) == 0)
S	{
S		return EMU_SUCCESS;
S	}
S	else
S	{
S		return EMU_FAILURE;
S	}
S
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI Uint32  EMU_getEALLOW(
S    void
S)
S{
S	return(EMU_FGET(DBGSTAT, EALLOWST));
S}
S
S/*------------------------------------------------------------------------*/
S
SCSLAPI Uint32  EMU_getDBGSTAT(
S    void
S)
S{
S	return(EMU_RGET(DBGSTAT));
S}
S
S/*------------------------------------------------------------------------*/
S
N#endif /* EMU_SUPPORT */
N
N/**************************************************************************\
N* End of csl_emu.c
X
N\**************************************************************************/
