/*
 * FPGA_interface.h
 */

#ifndef HEADER_FPGA_INTERFACE_H_
#define HEADER_FPGA_INTERFACE_H_

#include <main.h>


//      ( )
#define TVG_IO_READ_ADDR                0x0000

#define TVG_IO_XS_OFFSET                0x0000 // int32 (19  )
#define TVG_IO_XC_OFFSET                0x0002 // int32
#define TVG_IO_YS_OFFSET                0x0004 // int32
#define TVG_IO_YC_OFFSET                0x0006 // int32
//#define TVG_IO_S_OFFSET                   0x0008 // int32
#define TVG_IO_REG_INVERS_OFFSET          0x000A // int16_t

//      ( )
#define TVG_IO_WRITE_ADDR               0x0040      // 16 * (4)

//  :
#define TVG_IO_PLL_OFFSET               0x0000 // int32
#define TVG_IO_F0_OFFSET                0x0002 // Uint32

//  :
#define TVG_IO_NRX_OFFSET               0x0004 // int16_t,  
#define TVG_IO_NRY_OFFSET               0x0005 // int16_t
#define TVG_IO_NPX_OFFSET               0x0006 // int16_t,  
#define TVG_IO_NPY_OFFSET               0x0007 // int16_t
#define TVG_IO_NAX_OFFSET               0x0008 // int16_t,  
#define TVG_IO_NAY_OFFSET               0x0009 // int16_t
#define TVG_IO_R1_OFFSET               0x000a // TTVGR1
#define TVG_IO_R2_OFFSET               0x000b // TTVGR1
#define TVG_IO_NRPWM_OFFSET               0x000c // int16_t
#define TVG_IO_NPPWM_OFFSET               0x000d // int16_t
#define TVG_IO_NAPWM_OFFSET               0x000e // int16_t

void tvgISR (void);



#endif /* HEADER_FPGA_INTERFACE_H_ */
