/******************************************************************************\
*           Copyright (C) 1999-2000 Texas Instruments Incorporated.
*                           All Rights Reserved
*------------------------------------------------------------------------------
* FILENAME...... _csl_irq.c
* DATE CREATED.. 02/02/2001
\******************************************************************************/
#include "csl_irq.h"

#if (IRQ_SUPPORT)
/******************************************************************************\
*                         L O C A L   S E C T I O N
\******************************************************************************/

/* We need to use the runtime library intrinsic _lmbd() function but */
extern far Uint32 _lmbd(Uint32 src1, Uint32 src2);

extern far void _IRQ_vecs();

/******************************************************************************\
* static macro declarations
\******************************************************************************/


/******************************************************************************\
* static typedef declarations
\******************************************************************************/


/******************************************************************************\
* static function declarations
\******************************************************************************/
static void dummyIsr(Uint32 arg, Uint32 eventId);


/******************************************************************************\
* static variable definitions
\******************************************************************************/

/******************************************************************************\
* static function definitions
\******************************************************************************/

/*----------------------------------------------------------------------------*/
void dummyIsr(Uint32 arg, Uint32 eventId) {
}

/*----------------------------------------------------------------------------*/

/******************************************************************************\
*                        G L O B A L   S E C T I O N
\******************************************************************************/


/******************************************************************************\
* global variable definitions
\******************************************************************************/
_IRQ_Dispatch _IRQ_internalDispatchTable[_IRQ_DISPATCHTABLE_CNT] = {
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000},
  {dummyIsr, IRQ_IEMASK_DEFAULT, IRQ_CCMASK_DEFAULT, 0x00000000}
};

/******************************************************************************\
* global function definitions
\******************************************************************************/

/*----------------------------------------------------------------------------*/
void IRQ_dispatcherSetup() {

  int gie;

  gie = IRQ_globalDisable();

  _IRQ_init(IRQ_biosPresent(), _IRQ_internalDispatchTable);
  //IRQ_setVecs(0);
  IRQ_nmiEnable();
  gie = 1;

  IRQ_globalRestore(gie);
  
}

/*----------------------------------------------------------------------------*/


#endif /* IRQ_SUPPORT */
/******************************************************************************\
* End of _csl_irq.c
\******************************************************************************/

