/******************************************************************************\
*  Step 1.    Copyright (C) 2001 Texas Instruments Incorporated.
*                           All Rights Reserved
*------------------------------------------------------------------------------
* FILENAME...... csl_pll.c
* DATE CREATED.. 10/29/2001
* LAST MODIFIED. 10/29/2001 
*
\******************************************************************************/
/******************************************************************************\
*  Step 2. Private Macro and Include files *
\******************************************************************************/
#define _PLL_MOD_

#include "csl_pll.h"

#if (PLL_SUPPORT)
/******************************************************************************\
* Step 3.                        L O C A L   S E C T I O N
\******************************************************************************/
Uint32 _PLL_divAddr[4] = {
  _PLL_PLLDIV0_ADDR,
  _PLL_PLLDIV1_ADDR,
  _PLL_PLLDIV2_ADDR,
  _PLL_PLLDIV3_ADDR
};

/**********************************************\
* Step 3.1 PLL static macro declarations
\**********************************************/

/**********************************************\
* Step 3.2 PLL static typedef declarations
\**********************************************/

/**********************************************\
* Step 3.3 PLL static function declarations
\**********************************************/

/**********************************************\
* Step 3.4 PLL static variable definitions
\**********************************************/

/**********************************************\
* Step 3.5 PLL static function definitions
\**********************************************/
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/******************************************************************************\
* Step 4.                    G L O B A L   S E C T I O N
\******************************************************************************/

/**********************************************\
* Step 4.1 PLL global variable definitions
\**********************************************/

/**********************************************\
* Step 4.2 PLL global function definitions
\**********************************************/
void PLL_wait100() {
 volatile Uint32 x;

 for(x=0;x<80;x++) {
   asm(" NOP 1");
  } ;
}
  
Uint32 PLL_wait1() {
 PLL_FGET(PLLCSR,PLLRST);
 return ((Uint32) PLL_FGET(PLLDIV0,RATIO));
     
}
/**********************************************\
* Step 5. #endif PLL_SUPPORT + Footer
\**********************************************/
#endif /* PLL_SUPPORT */
/******************************************************************************\
* End of csl_pll.c
\******************************************************************************/
