/*
 * myTypes.h
 */

#ifndef MYTYPES_H_
#define MYTYPES_H_

/* Unsigned integer definitions (32bit, 16bit, 8bit) follow... */

typedef unsigned long long	Uint64;

/* Signed integer definitions (32bit, 16bit, 8bit) follow... */
typedef long long			Int64;

typedef unsigned long long  uint64;
typedef unsigned int        Uint32;
typedef unsigned int        uint32;
typedef unsigned short      uint16;
typedef unsigned short      Uint16;
typedef unsigned char       uint8;

/* Signed integer definitions (32bit, 16bit, 8bit) follow... */
typedef long long           int64;
typedef int                 int32;
typedef short               int16;
typedef char                int8;



typedef float				Float32;
typedef double				Float64;

/* Constants */
#ifndef TRUE
#define TRUE				((Bool) 1)
#endif

#ifndef FALSE
#define FALSE				((Bool) 0)
#endif

#ifndef NULL
#define NULL    			((void*) 0 )
#endif

#endif /* MYTYPES_H_ */
